// OutputDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WinClient.h"
#include "OutputDlg.h"

#include "session.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSession * g_session;
extern int g_dispImageW;
extern int g_dispImageH;
extern int g_playerJob;

/////////////////////////////////////////////////////////////////////////////
// COutputDlg

IMPLEMENT_DYNCREATE(COutputDlg, CFormView)

COutputDlg::COutputDlg()
	: CFormView(COutputDlg::IDD)
{
	//{{AFX_DATA_INIT(COutputDlg)
	m_step = 1;
	//}}AFX_DATA_INIT

	startImgIndex = endImgIndex = totalNoOfImgs = 0;
}

COutputDlg::~COutputDlg()
{
}

void COutputDlg::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COutputDlg)
	DDX_Text(pDX, IDC_STEP, m_step);
	DDX_Control(pDX, IDC_MEDIAPLAYER, m_player);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COutputDlg, CFormView)
	//{{AFX_MSG_MAP(COutputDlg)
	ON_BN_CLICKED(IDC_MOVELAST, OnMovelast)
	ON_BN_CLICKED(IDC_MOVENEXT, OnMovenext)
	ON_BN_CLICKED(IDC_MOVEPREV, OnMoveprev)
	ON_BN_CLICKED(IDC_MOVEFIRST, OnMovefirst)
	ON_WM_LBUTTONDBLCLK()
	ON_BN_CLICKED(IDC_CLEARVIDEO, OnClearvideo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COutputDlg diagnostics

#ifdef _DEBUG
void COutputDlg::AssertValid() const
{
	CFormView::AssertValid();
}

void COutputDlg::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COutputDlg message handlers

void COutputDlg::initialize()
{
	startImgIndex = 0;
	totalNoOfImgs = g_session->getResultsSize();

	if (totalNoOfImgs >= IMAGES_IN_DISPLAY)
	{
		endImgIndex = IMAGES_IN_DISPLAY - 1;
		GetDlgItem(IDC_MOVENEXT)->EnableWindow(TRUE);
		GetDlgItem(IDC_MOVELAST)->EnableWindow(TRUE);
	}
	else
	{
		endImgIndex = totalNoOfImgs - 1;
		GetDlgItem(IDC_MOVENEXT)->EnableWindow(FALSE);
		GetDlgItem(IDC_MOVELAST)->EnableWindow(FALSE);
	}
	GetDlgItem(IDC_MOVEPREV)->EnableWindow(FALSE);
	GetDlgItem(IDC_MOVEFIRST)->EnableWindow(FALSE);

	int crtCtrlId = (GetDlgItem(IDC_TEXT0))->GetDlgCtrlID();
	int i;

	if (startImgIndex >= endImgIndex)
	{
		crtCtrlId = (GetDlgItem(IDC_TEXT0))->GetDlgCtrlID();
		for (i =0; i<= IMAGES_IN_DISPLAY; i++)
		{
			SetDlgItemText(crtCtrlId,"");
			crtCtrlId = (GetNextDlgGroupItem(GetDlgItem(crtCtrlId),FALSE))->GetDlgCtrlID();	// get the next text box in the group
		}	
	}

	// clear the response time text box
	crtCtrlId = (GetDlgItem(IDC_RESPONSETIME))->GetDlgCtrlID();
	SetDlgItemText(crtCtrlId,"");
}
//-------------------------------------------------------------------------
void COutputDlg::OnDraw(CDC* pDC) 
{
	// TODO: Add your specialized code here and/or call the base class
	drawFrame(pDC);
	g_session->drawResultsInDlg(pDC,startImgIndex,endImgIndex, totalNoOfImgs);
}
//--------------------------------------------------------------------------
void COutputDlg::OnMovelast() 
{
	// TODO: Add your control notification handler code here
	endImgIndex = totalNoOfImgs - 1;
	GetDlgItem(IDC_MOVELAST)->EnableWindow(FALSE);
	GetDlgItem(IDC_MOVENEXT)->EnableWindow(FALSE);

	if (totalNoOfImgs < IMAGES_IN_DISPLAY)
		startImgIndex = 0;
	else
		startImgIndex = totalNoOfImgs - IMAGES_IN_DISPLAY;

	if (startImgIndex)
	{
		GetDlgItem(IDC_MOVEPREV)->EnableWindow(TRUE);
		GetDlgItem(IDC_MOVEFIRST)->EnableWindow(TRUE);
	}
	Invalidate();
	UpdateWindow();
}
//----------------------------------------------------------------------
void COutputDlg::OnMovefirst() 
{
	// TODO: Add your control notification handler code here
	startImgIndex = 0;
	GetDlgItem(IDC_MOVEFIRST)->EnableWindow(FALSE);
	GetDlgItem(IDC_MOVEPREV)->EnableWindow(FALSE);

	if (totalNoOfImgs < IMAGES_IN_DISPLAY)
		endImgIndex = totalNoOfImgs - 1;
	else
		endImgIndex = IMAGES_IN_DISPLAY - 1;

	if (endImgIndex < totalNoOfImgs)
	{
		GetDlgItem(IDC_MOVENEXT)->EnableWindow(TRUE);
		GetDlgItem(IDC_MOVELAST)->EnableWindow(TRUE);
	}
	Invalidate();
	UpdateWindow();
}

//--------------------------------------------------------------------------
void COutputDlg::OnMovenext() 
{
	// TODO: Add your control notification handler code here
	int realStep;

	UpdateData(TRUE);
	if (endImgIndex + m_step >= totalNoOfImgs)
		realStep = totalNoOfImgs - endImgIndex -1 ;
	else
		realStep = m_step;

	startImgIndex += realStep;
	endImgIndex += realStep;

	if (startImgIndex)
	{
		GetDlgItem(IDC_MOVEPREV)->EnableWindow(TRUE);
		GetDlgItem(IDC_MOVEFIRST)->EnableWindow(TRUE);
	}
	else
	{
		GetDlgItem(IDC_MOVEPREV)->EnableWindow(FALSE);
		GetDlgItem(IDC_MOVEFIRST)->EnableWindow(FALSE);
	}

	if (endImgIndex >= totalNoOfImgs -1)
	{
		GetDlgItem(IDC_MOVENEXT)->EnableWindow(FALSE);
		GetDlgItem(IDC_MOVELAST)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_MOVENEXT)->EnableWindow(TRUE);
		GetDlgItem(IDC_MOVELAST)->EnableWindow(TRUE);
	}
	Invalidate();
	UpdateWindow();
}
//----------------------------------------------------------------------
void COutputDlg::OnMoveprev() 
{
	// TODO: Add your control notification handler code here
	int realStep;

	UpdateData(TRUE);

	if (startImgIndex - m_step >= 0)
		realStep = m_step;
	else
		realStep = startImgIndex;

	startImgIndex -= realStep;
	endImgIndex -= realStep;

	if (startImgIndex)
	{
		GetDlgItem(IDC_MOVEPREV)->EnableWindow(TRUE);
		GetDlgItem(IDC_MOVEFIRST)->EnableWindow(TRUE);
	}
	else
	{
		GetDlgItem(IDC_MOVEPREV)->EnableWindow(FALSE);
		GetDlgItem(IDC_MOVEFIRST)->EnableWindow(FALSE);
	}

	if (endImgIndex >= totalNoOfImgs-1)
	{
		GetDlgItem(IDC_MOVENEXT)->EnableWindow(FALSE);
		GetDlgItem(IDC_MOVELAST)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_MOVENEXT)->EnableWindow(TRUE);
		GetDlgItem(IDC_MOVELAST)->EnableWindow(TRUE);
	}
	Invalidate();
	UpdateWindow();
}

//---------------------------------------------------------------------
void COutputDlg::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	clearVideo();

	CString URL;
	g_session->handleDoubleClickInDlg(point,startImgIndex,URL);
	m_player.Open(URL);

	CFormView::OnLButtonDblClk(nFlags, point);
}
//--------------------------------------------------------------------------------
void COutputDlg::drawFrame(CDC *pDC)
{
	int i;

	COLORREF col;
	for (i=XDISPLAY;i<(XDISPLAY + IMAGES_IN_DISPLAY * (g_dispImageW+10));i+= 10)
	{
		col = RGB(0,0,0);
		pDC->FillSolidRect(i,YDISPLAY -10,10,10,col);
		pDC->FillSolidRect(i,YDISPLAY + g_dispImageH,10,10,col);
		col = RGB(255,255,255);
		pDC->FillSolidRect(i+2,YDISPLAY-8,6,6,col);
		pDC->FillSolidRect(i+2,YDISPLAY + g_dispImageH + 2,6,6,col);
	}
}
//-----------------------------------------------------
void COutputDlg::OnClearvideo() 
{
	// TODO: Add your control notification handler code here
	clearVideo();
}
//-----------------------------------------------------

void COutputDlg::clearVideo()
{
	if (g_playerJob == PLAYERPLAYING)
	{
		m_player.Stop();
		m_player.Open("");
	}
	else if (g_playerJob == PLAYERSTREAMING)
	{
		g_session->execCommadQuery("stream_stop;");
		totalNoOfImgs = g_session->cleanAfterStreaming();
		m_player.Stop();
		m_player.Open("");
	}
	g_playerJob = PLAYERIDLE;
}
