/*
  BasicDef - basic definitions, public header file
  Copyright 1999-2000 Robert Tibljas and Zeljko Nikolic
*/

#ifndef  BASICDEF_H
#define  BASICDEF_H


#include  <stddef.h>


#ifdef  __cplusplus
extern "C" {
#endif


// boolean consts
#define  K_TRUE   1
#define  K_FALSE  0
// not defined, auto, etc.
#define  K_MAGIC   -1357902468
#define  K_AUTO    K_MAGIC
#define  K_NOTDEF  K_MAGIC
// direction
#define  K_FORWARD   +1
#define  K_BACKWARD  -1
// bits consts usually used for image depth values
#define  BITS_8   8
#define  BITS_15  15
#define  BITS_16  16
#define  BITS_24  24
#define  BITS_32  32

// basic types
typedef  unsigned char   Qcard8;
typedef  unsigned short  Qcard16;
typedef  unsigned long   Qcard32;
typedef  char            Qint8;   // -128..127
typedef  short           Qint16;  // -32768..32767
typedef  long            Qint32;
typedef  float           Qfloat32;
typedef  double          Qfloat64;
typedef  char            QansiChar;
typedef  wchar_t         QwideChar;
typedef  long            Qbool32;
// expanded
typedef  Qcard8     Qbyte;
typedef  Qcard16    Qword;
typedef  Qcard32    Qcard;
typedef  Qint32     Qint;
typedef  Qfloat64   Qfloat;
typedef  QansiChar  Qchar;
typedef  Qbool32    Qbool;
typedef  Qbyte      *QbyteP;
typedef  Qword      *QwordP;
typedef  Qcard      *QcardP;
typedef  Qint       *QintP;
typedef  Qfloat     *QfloatP;
typedef  Qchar      *QcharP;
typedef  Qbool      *QboolP;


#ifdef __cplusplus
}
#endif

#endif  // BASICDEF_H
