#include "stdafx.h"
#include "stdlib.h"
#include "global.h"
#include "frame.h"
#include "time.h"

#include <math.h>

//================================================
float getAbsolute(float x)
{
	if (x<0) 
		return (-x);
	else
		return (x);
}

//----------------------------------------------------
int getMin(float *f, int fSize)
{
	/* return the index of the array of the min element in it. f is the array of 
	values and fSize is the size of the array */

	int min=0;
	for(int i= 1;i<fSize;i++)
	{
		if(f[i] <f[min]) min=i;
	}
	return min;
}
//-----------------------------------------------------
COLORREF YUVToRGB(BYTE y, BYTE  u, BYTE v)

{

	float r,g,b;
			
	r = (float) y + (float) v - 128;
	b = (float) y + (float) u - 128;
	g = (float) (((float)y - 0.299*(float)r-0.114*(float)b)/(float) 0.587);

	if (r < 0) r=0; if (r > 255) r=255;
	if (g < 0) g=0;	if (g > 255) g=255;
	if (b < 0) b=0;	if (b > 255) b=255;

		
	return RGB((BYTE) r,(BYTE) g,(BYTE) b);

}

//------------------------------------------------------
void YUV2R_G_B(CFrame *crtFrame,unsigned char *r, unsigned char *g, unsigned char *b)
{
	int cnt = 0;
	for (int i=0; i < crtFrame->height; i++)
	{
		for (int j=0; j < crtFrame->width; j++)
		{
			b[cnt] = 1.164*(crtFrame->Y[i][j] - 16) + 2.018*(crtFrame->V[i/2][j/2] - 128);
			g[cnt] = 1.164*(crtFrame->Y[i][j] - 16) - 0.813*(crtFrame->U[i/2][j/2] - 128) - 0.391*(crtFrame->V[i/2][j/2] - 128);
			r[cnt] = 1.164*(crtFrame->Y[i][j] - 16) + 1.596*(crtFrame->U[i/2][j/2] - 128);
			cnt++;
		}
	}
}
//--------------------------------------------------------
int getRandomNumber(int min, int max)
{
	// the seed should be initialized in the main program with srand()
	int x;

	if (min == max)
		return (max);

	// get a random number between x and y
	x = rand()%max;
	
	if (x >= min)
	{
		return (x);
	}
	else
	{
		x = x * ((max-min)/min) + min;
	}
	if (!between(x,min,max))
	{
		AfxMessageBox("error calculating random value");
		return ((min+max) / 2);
	}
	return(x) ;
}
//-----------------------------------------------------------
int between(double n, double x, double y)
{
	double min=0,max=0;
	// return 1 if n between x and y and 0 otherwise
	if (x <= y)
	{
		min = x;
		max = y;
	}
	else
	{
		min = y;
		max = x;
	}

	if (n >= min && n<=max)
		return (1);
	else
		return (0);
}

//-----------------------------------------------------------------
char * getStringFromArray(float *h, int dim)
{
	char l[10000], temp[50];

	strcpy(l,"");
	for (int i=0;i < dim ; i++)
	{
		if (!h[i])
			strcat(l," 0");
		else
		{
			sprintf(temp," %f",h[i]);
			strcat(l,temp);
		}
	}
	return l;
}
//--------------------------------------------------------------------
int getThreshold(int *f, int maxSize,float initialP1)
{
	float P0T,P1T,P0T1,P1T1,H0T,H1T,H0T1,H1T1,maxEntropy;
	int i,T;

	P0T = 1;				// P0(T)
	P1T = initialP1;		// P1(T)
	H0T = 0;				// Hsc(T)
	H1T = 0;				// Hnsc(T)

	for (i=0; i< maxSize ;i++)
		if (f[i])
			H1T += - (f[i]/P1T) * (float) log(f[i]/P1T);

	maxEntropy = 0;
	T = 0;

	for (i=0;i < maxSize;i++)
	{
		if (f[i])
		{
			P0T1 = P0T + f[i];
			P1T1 = P1T - f[i];
			H0T1 = (float) (P0T*H0T - f[i]*log(f[i]/P0T1) - P0T*log(P0T/P0T1))/P0T1;
			H1T1 = (float) (P1T*H1T + f[i]*log(f[i]/P1T1) - P1T*log(P1T/P1T1))/P1T1;
	
			if (H0T1 + H1T1 > maxEntropy)
			{
				maxEntropy = H1T1 + H0T1;
				T = i;
			}

			H0T = H0T1;
			H1T = H1T1;
			P0T = P0T1;
			P1T = P1T1;
		}
	}

	return(T);
}