// InputDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WinClient.h"
#include "InputDlg.h"

#include "Session.h"
//#include "MyScrollView.h"
#include "frame.h"
#include "cursorRecord.h"
#include <afxtempl.h>
#include "outputDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int g_dispErrors;
extern CArray <CursorRecord*, CursorRecord*> g_cursor;
extern double qResponseTime;
extern int g_useYUVFile;
extern int g_playerJob;

#ifdef _DEBUG
    CMemoryState oldMemState, newMemState, diffMemState;
	#include <crtdbg.h>
	_CrtMemState s1, s2, s3;
#endif

#define PAN_LEFT   1
#define PAN_RIGHT  2
#define TILT_UP    3
#define TILT_DOWN  4
#define ZOOM_IN    5
#define ZOOM_OUT   6
#define IRREGULAR  7
#define STILL      8

/////////////////////////////////////////////////////////////////////////////
// InputDlg

IMPLEMENT_DYNCREATE(CInputDlg, CFormView)

CInputDlg::CInputDlg()
	: CFormView(CInputDlg::IDD)
{
	//{{AFX_DATA_INIT(CInputDlg)
	m_sql = _T("");
	m_fileName = _T("");
	m_CH = TRUE;
	m_CL = FALSE;
	m_CM = FALSE;
	m_TE = FALSE;
	m_TT = FALSE;
	m_MH = FALSE;
	m_k = 5;
	m_errorMsgs = FALSE;
	m_degree = 5;
	m_CH2 = FALSE;
	m_useYUVFile = TRUE;
	m_rank = FALSE;
	m_DC = FALSE;
	m_EH = FALSE;
	m_HT = FALSE;
	m_SC = FALSE;
	//}}AFX_DATA_INIT
}

CInputDlg::~CInputDlg()
{
}

void CInputDlg::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInputDlg)
	DDX_Control(pDX, IDC_RADIO_TILTU, m_Radio_TiltU);
	DDX_Control(pDX, IDC_RADIO_TILTD, m_Radio_TiltD);
	DDX_Control(pDX, IDC_RADIO_IRREGULAR, m_Radio_Irregular);
	DDX_Control(pDX, IDC_RADIO_ZoomO, m_Radio_ZoomO);
	DDX_Control(pDX, IDC_RADIO_ZoomI, m_Radio_ZoomI);
	DDX_Control(pDX, IDC_RADIO_STILL, m_Radio_Still);
	DDX_Control(pDX, IDC_RADIO_PANR, m_Radio_PanR);
	DDX_Control(pDX, IDC_RADIO_PANL, m_Radio_PanL);
	DDX_Control(pDX, IDC_RADIO_FRAMESHOT, m_Radio_FrameShot);
	DDX_Control(pDX, IDC_RADIO_FRAMEFRAME, m_Radio_FrameFrame);
	DDX_Control(pDX, IDC_RADIO_SHOT, m_Radio_Shot);
	DDX_Control(pDX, IDC_RADIO_SQL, m_Radio_Sql);
	DDX_Control(pDX, IDC_RADIO_QUERYBYEXAMPLE, m_Radio_QyeryByExample);
	DDX_Control(pDX, IDC_RADIO_EXECBATCH, m_Radio_ExecBatch);
	DDX_Control(pDX, IDC_RADIO_MOTIONINFO, m_Radio_MotionInfo);
	DDX_Control(pDX, IDC_RADIO_KEYWORD, m_Radio_KeyWord);
	DDX_Text(pDX, IDC_SQL, m_sql);
	DDV_MaxChars(pDX, m_sql, 30000);
	DDX_Text(pDX, IDC_FILENAME, m_fileName);
	DDX_Check(pDX, IDC_CH, m_CH);
	DDX_Check(pDX, IDC_CL, m_CL);
	DDX_Check(pDX, IDC_CM, m_CM);
	DDX_Check(pDX, IDC_TE, m_TE);
	DDX_Check(pDX, IDC_TT, m_TT);
	DDX_Check(pDX, IDC_MH, m_MH);
	DDX_Text(pDX, IDC_K, m_k);
	DDX_Check(pDX, IDC_DISPLAYERROR, m_errorMsgs);
	DDX_Text(pDX, IDC_DEGREE, m_degree);
	DDX_Check(pDX, IDC_CH2, m_CH2);
	DDX_Check(pDX, IDC_USEYUVFILE, m_useYUVFile);
	DDX_Check(pDX, IDC_RANK, m_rank);
	DDX_Check(pDX, IDC_DC, m_DC);
	DDX_Check(pDX, IDC_EH, m_EH);
	DDX_Check(pDX, IDC_HT, m_HT);
	DDX_Check(pDX, IDC_SC, m_SC);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInputDlg, CFormView)
	//{{AFX_MSG_MAP(CInputDlg)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_EXECQUERY, OnExecquery)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_CLEARFILENAME, OnClearfilename)
	ON_BN_CLICKED(IDC_SHOWSQL, OnShowsql)
	ON_BN_CLICKED(IDC_CLEARSQL, OnClearsql)
	ON_BN_CLICKED(IDC_SELECTFILE, OnSelectfile)
	ON_BN_CLICKED(IDC_RADIO_SQL, OnRadioSql)
	ON_BN_CLICKED(IDC_RADIO_QUERYBYEXAMPLE, OnRadioQuerybyexample)
	ON_BN_CLICKED(IDC_RADIO_EXECBATCH, OnRadioExecbatch)
	ON_BN_CLICKED(IDC_RADIO_MOTIONINFO, OnRadioMotioninfo)
	ON_BN_CLICKED(IDC_RADIO_KEYWORD, OnRadioKeyword)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// InputDlg diagnostics

#ifdef _DEBUG
void CInputDlg::AssertValid() const
{
	CFormView::AssertValid();
}

void CInputDlg::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// InputDlg message handlers

void CInputDlg::OnConnect() 
{
	// TODO: Add your control notification handler code here
	#ifdef _DEBUG
	    oldMemState.Checkpoint();
		_CrtMemCheckpoint( &s1 );
	#endif

	g_session = new CSession();
	GetDlgItem(IDC_DISCONNECT)->EnableWindow(TRUE);	// enable DISCONNECT
	GetDlgItem(IDC_EXECQUERY)->EnableWindow(TRUE);
	GetDlgItem(IDC_CONNECT)->EnableWindow(FALSE);
}
//----------------------------------------------------------------------
void CInputDlg::OnExecquery() 
{
	// TODO: Add your control notification handler code here
	int status;

	UpdateData(TRUE);
	g_dispErrors = m_errorMsgs;
	CString sql;
	qResponseTime = 0;
	if (m_Radio_QyeryByExample.GetState())	// the user selected query by example
	{
		if (!m_Radio_Shot.GetState() && !m_Radio_FrameFrame.GetState() && !m_Radio_FrameShot.GetState())
		{
			AfxMessageBox("You Selected Query By Example.. \nPlease select the level of query you will submit.");
			return;
		}

		if (m_fileName =="")
		{
			AfxMessageBox("Please select a file as an example");
			return;
		}

		// construct the sql statement
		if (constructSQL(sql)) 
		{
			g_session->execQuery(sql);
			// delete from the temp table;
			g_session->execQuery("delete from SeqTemp ;");
			g_session->execQuery("delete from bar ;");
		}
		else
		{
			AfxMessageBox("Can't construct SQL Statement");
			return;
		}
	}
	else if (m_Radio_Sql.GetState())	// the user selected to write an SQL
	{
		if (m_sql == "")
		{
			AfxMessageBox("Please write an SQL statement to execute");
			return;
		}
		else
			status = g_session->execQuery(m_sql);
	}
	else if (m_Radio_ExecBatch.GetState())	// the user selected to execute batch
	{
		if (m_fileName =="")
		{
			AfxMessageBox("Please select a batch file to be executed");
			return;
		}

		// execute the batch file
		g_session->execBatch(m_fileName);
	}
	else if (m_Radio_MotionInfo.GetState())	// the user select to query on motion Information
	{
		if (!m_Radio_PanL.GetState() && !m_Radio_PanR.GetState() && !m_Radio_TiltU.GetState() && !m_Radio_TiltD.GetState() && !m_Radio_ZoomI.GetState() && !m_Radio_ZoomO.GetState() && !m_Radio_Still.GetState() && !m_Radio_Irregular.GetState())
		{
			AfxMessageBox("You selected to query by Motion Information in the shots\nPlease select the type and degree of motion");
			return;
		}

		if (constructSQL(sql))
			g_session->execQuery(sql);
		else
		{
			AfxMessageBox("Can't construct SQL Statement");
			return;
		}
	}
	else if (m_Radio_KeyWord.GetState())	// query by key words
	{
		if (m_sql == "")
		{
			AfxMessageBox("Please enter a list of key words.. Key words should be comma sepaprated");
			return;
		}

		if (constructSQL(sql))
			g_session->execQuery(sql);
		else
		{
			AfxMessageBox("Can't construct SQL Statement");
			return;
		}
	}
	else	// nothing selected
	{
		AfxMessageBox("Please select the query type you will submit.");
		return;
	}


	redrawView();	// draw the results

	GetDlgItem(IDC_CLEAR)->EnableWindow(TRUE);
	
	/* This is to handle the case that the save reply returned back without
	reading all the values returned from the server. For now this query has 
	to be an SQL query */
	if (m_Radio_Sql.GetState() && status == IGNORERESULT)
		g_session->readBuffer2ndThread();
}

//------------------------------------------------------------------------------
void CInputDlg::OnExit() 
{
	// TODO: Add your control notification handler code here
	g_session->clearResults();
	if (g_session)
	{
		delete (g_session);
		g_session = 0;
	}
	exit(EXIT_SUCCESS);
}

//-----------------------------------------------------------------------------
void CInputDlg::OnDisconnect() 
{
	// TODO: Add your control notification handler code here
	if (g_playerJob == PLAYERSTREAMING)
	{
		AfxMessageBox("Please stop the streaming process first");
		return;
	}
	// kill the read thread
	if (g_session->m_pReadWorkerThread != NULL)
		g_session->killReadBufferThread();

	// clear the results
	OnClear();
	if (g_session)
	{
		delete (g_session);
		g_session = 0;
	}
	#ifdef _DEBUG
		oldMemState.DumpAllObjectsSince();
		newMemState.Checkpoint();
		_CrtMemDumpAllObjectsSince(&s1);
		_CrtMemCheckpoint(&s2);
		if ( _CrtMemDifference( &s3, &s1, &s2 ) )
		      _CrtMemDumpStatistics( &s3 );

		if( diffMemState.Difference( oldMemState, newMemState ) )
		{
			TRACE( "Memory leaked (New and Delete)!\n" );
		}
	#endif

		
	GetDlgItem(IDC_DISCONNECT)->EnableWindow(FALSE);	// enable DISCONNECT
	GetDlgItem(IDC_EXECQUERY)->EnableWindow(FALSE);
	GetDlgItem(IDC_CONNECT)->EnableWindow(TRUE);
	GetDlgItem(IDC_CLEAR)->EnableWindow(FALSE);
}

//------------------------------------------------------------------------------
void CInputDlg::OnClear() 
{
	// TODO: Add your control notification handler code here
	// clear the results in the g_session array
	g_session->clearResults();
	redrawView();

	GetDlgItem(IDC_CLEAR)->EnableWindow(FALSE);
}

//-------------------------------------------------------------------------------
void CInputDlg::redrawView()
{
	CSplitterWnd *parent;	
	//CMyScrollView *drawPaneView;
	COutputDlg *drawPaneView;

	parent = (CSplitterWnd *) GetParent();	// the first level splitter window
	//drawPaneView = (CMyScrollView*) parent->GetPane(1,0);
	drawPaneView = (COutputDlg*) parent->GetPane(1,0);
	
	//drawPaneView->clearVideo();	// Clear the video

	drawPaneView->initialize();
	drawPaneView->Invalidate();
	drawPaneView->UpdateWindow();
}

//--------------------------------------------------------------------------
void CInputDlg::OnDraw(CDC* pDC) 
{
	// TODO: Add your specialized code here and/or call the base class
	HDC  hDC;  	// a handle to a device context
	HANDLE hFile;
	hDC = pDC->m_hDC;    
	if( ( hFile = ::CreateFile(m_fileName ,GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 
	   FILE_ATTRIBUTE_NORMAL| FILE_FLAG_SEQUENTIAL_SCAN, NULL ) ) != INVALID_HANDLE_VALUE )
	{ 
		DWORD  dwSize  = DWORD( ::GetFileSize( hFile, NULL ) );
		HGLOBAL hMemory = ::GlobalAlloc( GMEM_MOVEABLE, dwSize );
		LPVOID  pData = ::GlobalLock( hMemory );
		DWORD  dwCount;
		::ReadFile( hFile, pData, dwSize,  &dwCount, NULL );
		::GlobalUnlock( hMemory );
		IStream * pStream  = NULL;
		::CreateStreamOnHGlobal( hMemory, TRUE, &pStream );
		IPicture * pPicture = NULL;
		if( SUCCEEDED( ::OleLoadPicture( pStream, dwSize, TRUE, IID_IPicture,( LPVOID* )&pPicture ) ) )
		{ 
			OLE_XSIZE_HIMETRIC hmWidth;
			OLE_YSIZE_HIMETRIC hmHeight;
			pPicture->get_Width( &hmWidth );
			pPicture->get_Height( &hmHeight );
			pPicture->Render(hDC, 625, 165, 200, 140, 0, hmHeight, hmWidth, -hmHeight, NULL );
			pPicture->Release();
		}
		pStream->Release();
		::GlobalFree(hMemory);
		::CloseHandle( hFile );
	}
}

//----------------------------------------------------------------------------
void CInputDlg::OnClearfilename() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_fileName = "";
	UpdateData(FALSE);
	Invalidate();
	UpdateWindow();
}

//----------------------------------------------------------------------------
int CInputDlg::constructSQL(CString &sql, bool execute)
{
	int x = 0;

	if (m_Radio_QyeryByExample.GetState())
	{
		int y = getTypeOfQBEJoin();
		if (!y)
			return 0;
		else if (y == 1)
			x = constructSQLQBEJoin(sql, execute);
		else	// y = 2
			x = constructSQLQBERJoin(sql, execute);
	}
	else if (m_Radio_MotionInfo.GetState())
		x = constructSQLMotionInfo(sql);
	else if (m_Radio_KeyWord.GetState())
		x = constructSQLKeyWords(sql);
	else
		return 0;

	if (!m_Radio_KeyWord.GetState())
		m_sql = sql;
	UpdateData(FALSE);
	UpdateWindow();

	return x;
}

//-------------------------------------------------------------------
void CInputDlg::OnShowsql() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	CString sql;
	constructSQL(sql,false);
	m_sql = sql;
	UpdateData(FALSE);
	UpdateWindow();
}

//------------------------------------------------------------------
int CInputDlg::getFileName(CString &fileName)
{
	char display[10000];
	BROWSEINFO	bi;	// to provide the brose dialog box
	LPITEMIDLIST list;	// return the selection of the user from the browse box

	bi.hwndOwner = AfxGetMainWnd( )->m_hWnd; 
	bi.pidlRoot = NULL; 
	bi.pszDisplayName = display; 
	bi.lpszTitle = "Please choose an Image:"; 
	bi.ulFlags = BIF_EDITBOX | BIF_BROWSEINCLUDEFILES | BIF_STATUSTEXT ;
	bi.lpfn = NULL; 
	list = SHBrowseForFolder( &bi);	//Displays a dialog box that enables the user to select a shell folder.
	if(list == NULL) 
	{
		return 0;
	};

	SHGetPathFromIDList( list, display);	// Converts an item identifier list to a file system path. 
	fileName = (const char *) display;
	return 1;
}

//--------------------------------------------------------------------------
void CInputDlg::OnClearsql() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_sql = "";
	UpdateData(FALSE);
	UpdateWindow();
}

//--------------------------------------------------------------------------
void CInputDlg::OnSelectfile() 
{
	// TODO: Add your control notification handler code here
	if (getFileName(m_fileName))
	{
		UpdateData(FALSE);
		UpdateWindow();
		if (m_Radio_QyeryByExample.GetState())
			Invalidate();
	}
}

//--------------------------------------------------------------------------
void CInputDlg::OnRadioSql() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_SELECTFILE)->EnableWindow(FALSE);
	GetDlgItem(IDC_REFRESH)->EnableWindow(FALSE);
	GetDlgItem(IDC_SHOWSQL)->EnableWindow(FALSE);

	// disable the level of query controls.
	GetDlgItem(IDC_STATIC_LEVEL)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_SHOT)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_FRAMESHOT)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_FRAMEFRAME)->EnableWindow(FALSE);

	// disable Motion Info and features
	GetDlgItem(IDC_CH)->EnableWindow(FALSE);
	GetDlgItem(IDC_CH2)->EnableWindow(FALSE);
	GetDlgItem(IDC_CM)->EnableWindow(FALSE);
	GetDlgItem(IDC_CL)->EnableWindow(FALSE);
	GetDlgItem(IDC_TT)->EnableWindow(FALSE);
	GetDlgItem(IDC_TE)->EnableWindow(FALSE);
	GetDlgItem(IDC_MH)->EnableWindow(FALSE);
	GetDlgItem(IDC_DC)->EnableWindow(FALSE);
	GetDlgItem(IDC_SC)->EnableWindow(FALSE);
	GetDlgItem(IDC_HT)->EnableWindow(FALSE);
	GetDlgItem(IDC_EH)->EnableWindow(FALSE);
	GetDlgItem(IDC_K)->EnableWindow(FALSE);
	GetDlgItem(IDC_RANK)->EnableWindow(FALSE);

	GetDlgItem(IDC_RADIO_PANL)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_PANR)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_TILTU)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_TILTD)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_ZoomI)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_ZoomO)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_IRREGULAR)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_STILL)->EnableWindow(FALSE);
	GetDlgItem(IDC_DEGREE)->EnableWindow(FALSE);
}

//--------------------------------------------------------------------------
void CInputDlg::OnRadioQuerybyexample() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_SELECTFILE)->EnableWindow(TRUE);
	GetDlgItem(IDC_REFRESH)->EnableWindow(TRUE);
	GetDlgItem(IDC_SHOWSQL)->EnableWindow(TRUE);	

	// enable the level of query controls and select the first option if nothing else is selected.
	GetDlgItem(IDC_STATIC_LEVEL)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_SHOT)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_FRAMESHOT)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_FRAMEFRAME)->EnableWindow(TRUE);
	if (!m_Radio_Shot.GetState() && !m_Radio_FrameShot.GetState() && !m_Radio_FrameFrame.GetState())
		m_Radio_Shot.SetCheck(1);
	
	// disable Motion Info and enable features
	GetDlgItem(IDC_CH)->EnableWindow(TRUE);
	GetDlgItem(IDC_CH2)->EnableWindow(TRUE);
	GetDlgItem(IDC_CM)->EnableWindow(TRUE);
	GetDlgItem(IDC_CL)->EnableWindow(TRUE);
	GetDlgItem(IDC_TT)->EnableWindow(TRUE);
	GetDlgItem(IDC_TE)->EnableWindow(TRUE);
	GetDlgItem(IDC_MH)->EnableWindow(TRUE);
	GetDlgItem(IDC_DC)->EnableWindow(TRUE);
	GetDlgItem(IDC_SC)->EnableWindow(TRUE);
	GetDlgItem(IDC_HT)->EnableWindow(TRUE);
	GetDlgItem(IDC_EH)->EnableWindow(TRUE);
	GetDlgItem(IDC_K)->EnableWindow(TRUE);
	GetDlgItem(IDC_RANK)->EnableWindow(TRUE);

	GetDlgItem(IDC_RADIO_PANL)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_PANR)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_TILTU)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_TILTD)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_ZoomI)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_ZoomO)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_IRREGULAR)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_STILL)->EnableWindow(FALSE);
	GetDlgItem(IDC_DEGREE)->EnableWindow(FALSE);
}

//--------------------------------------------------------------------------
void CInputDlg::OnRadioExecbatch() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_SELECTFILE)->EnableWindow(TRUE);
	GetDlgItem(IDC_REFRESH)->EnableWindow(FALSE);
	GetDlgItem(IDC_SHOWSQL)->EnableWindow(FALSE);

	// enable the level of query controls.
	GetDlgItem(IDC_STATIC_LEVEL)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_SHOT)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_FRAMESHOT)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_FRAMEFRAME)->EnableWindow(FALSE);

	// disable Motion Info and features
	GetDlgItem(IDC_CH)->EnableWindow(FALSE);
	GetDlgItem(IDC_CH2)->EnableWindow(FALSE);
	GetDlgItem(IDC_CM)->EnableWindow(FALSE);
	GetDlgItem(IDC_CL)->EnableWindow(FALSE);
	GetDlgItem(IDC_TT)->EnableWindow(FALSE);
	GetDlgItem(IDC_TE)->EnableWindow(FALSE);
	GetDlgItem(IDC_MH)->EnableWindow(FALSE);
	GetDlgItem(IDC_DC)->EnableWindow(FALSE);
	GetDlgItem(IDC_SC)->EnableWindow(FALSE);
	GetDlgItem(IDC_HT)->EnableWindow(FALSE);
	GetDlgItem(IDC_EH)->EnableWindow(FALSE);
	GetDlgItem(IDC_K)->EnableWindow(FALSE);
	GetDlgItem(IDC_RANK)->EnableWindow(FALSE);

	GetDlgItem(IDC_RADIO_PANL)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_PANR)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_TILTU)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_TILTD)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_ZoomI)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_ZoomO)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_IRREGULAR)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_STILL)->EnableWindow(FALSE);
	GetDlgItem(IDC_DEGREE)->EnableWindow(FALSE);
}

//------------------------------------------------------------------------------------
int CInputDlg::constructSQLMotionInfo(CString &sql)
{
	int motionType;

	if (m_Radio_PanL.GetState())
		motionType = PAN_LEFT;
	else if (m_Radio_PanR.GetState())
		motionType = PAN_RIGHT;
	else if (m_Radio_TiltU.GetState())
		motionType = TILT_UP;
	else if (m_Radio_TiltD.GetState())
		motionType = TILT_DOWN;
	else if (m_Radio_ZoomI.GetState())
		motionType = ZOOM_IN;
	else if (m_Radio_ZoomO.GetState())
		motionType = ZOOM_OUT;
	else if (m_Radio_Irregular.GetState())
		motionType = IRREGULAR;
	else if (m_Radio_Still.GetState())
		motionType = STILL;

	char cond[1000];
	CString select;
	select = "select m.VideoId, m.MotionType, m.StartFrame, m.EndFrame, v.Movie.GetFrame(m.StartFrame) from CameraMotion m, VideoStream v  ";
	sprintf(cond," where m.VideoId = v.VideoId and m.MotionType=%d and m.EndFrame - m.StartFrame>=%d;",motionType,m_degree);

	sql = select + (const char *) cond;

	return 1;
}
//--------------------------------------------------------------------
int CInputDlg::constructSQLKeyWords(CString &sql)
{
	CString cond, select, temp;
	int pos1,pos2;
	sql = m_sql;	// list of key words;

	// get the list of kwy words from the user input
	pos1= pos2 =0;
	while (1)
	{
		pos2 = sql.Find(",",pos1);
		if (pos2 == -1)
			temp = sql.Mid(pos1);
		else
			temp = sql.Mid(pos1,pos2-pos1);

		temp.TrimLeft();
		temp.TrimRight();
		cond += " and vs.KeyWord like \"" + temp + "\"";

		if (pos2==-1)
			break;
		else
			pos1 = pos2+1;
	}

	cond += ";";
	select = "Select vs.VideoId, vs.Level, vs.StartFrame, vs.EndFrame, v.Movie.GetFrame(vs.StartFrame) from VideoScenes vs, VideoStream v where vs.VideoId = v.VideoId ";
	sql = select + cond;
	return 1;
}

//-----------------------------------------------------------------
void CInputDlg::OnRadioMotioninfo() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_SELECTFILE)->EnableWindow(FALSE);
	GetDlgItem(IDC_REFRESH)->EnableWindow(FALSE);
	GetDlgItem(IDC_SHOWSQL)->EnableWindow(TRUE);	

	// disable the level of query controls.
	GetDlgItem(IDC_STATIC_LEVEL)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_SHOT)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_FRAMESHOT)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_FRAMEFRAME)->EnableWindow(FALSE);

	// enable Motion Info and disable features
	GetDlgItem(IDC_CH)->EnableWindow(FALSE);
	GetDlgItem(IDC_CH2)->EnableWindow(FALSE);
	GetDlgItem(IDC_CM)->EnableWindow(FALSE);
	GetDlgItem(IDC_CL)->EnableWindow(FALSE);
	GetDlgItem(IDC_TT)->EnableWindow(FALSE);
	GetDlgItem(IDC_TE)->EnableWindow(FALSE);
	GetDlgItem(IDC_MH)->EnableWindow(FALSE);
	GetDlgItem(IDC_DC)->EnableWindow(FALSE);
	GetDlgItem(IDC_SC)->EnableWindow(FALSE);
	GetDlgItem(IDC_HT)->EnableWindow(FALSE);
	GetDlgItem(IDC_EH)->EnableWindow(FALSE);
	GetDlgItem(IDC_K)->EnableWindow(FALSE);
	GetDlgItem(IDC_RANK)->EnableWindow(FALSE);

	GetDlgItem(IDC_RADIO_PANL)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_PANR)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_TILTU)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_TILTD)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_ZoomI)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_ZoomO)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_IRREGULAR)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_STILL)->EnableWindow(TRUE);
	GetDlgItem(IDC_DEGREE)->EnableWindow(TRUE);
	if (!m_Radio_PanL.GetState() && !m_Radio_PanR.GetState() && !m_Radio_TiltD.GetState() && !m_Radio_TiltU.GetState() && !m_Radio_ZoomI.GetState() && !m_Radio_ZoomO.GetState() && !m_Radio_Irregular.GetState() && !m_Radio_Still.GetState())
		m_Radio_PanL.SetCheck(1);
}
//-----------------------------------------------------------------

void CInputDlg::OnRadioKeyword() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_SELECTFILE)->EnableWindow(FALSE);
	GetDlgItem(IDC_REFRESH)->EnableWindow(FALSE);
	GetDlgItem(IDC_SHOWSQL)->EnableWindow(FALSE);	

	// disable the level of query controls.
	GetDlgItem(IDC_STATIC_LEVEL)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_SHOT)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_FRAMESHOT)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_FRAMEFRAME)->EnableWindow(FALSE);

	// disable Motion Info and features
	GetDlgItem(IDC_CH)->EnableWindow(FALSE);
	GetDlgItem(IDC_CH2)->EnableWindow(FALSE);
	GetDlgItem(IDC_CM)->EnableWindow(FALSE);
	GetDlgItem(IDC_CL)->EnableWindow(FALSE);
	GetDlgItem(IDC_TT)->EnableWindow(FALSE);
	GetDlgItem(IDC_TE)->EnableWindow(FALSE);
	GetDlgItem(IDC_MH)->EnableWindow(FALSE);
	GetDlgItem(IDC_DC)->EnableWindow(FALSE);
	GetDlgItem(IDC_SC)->EnableWindow(FALSE);
	GetDlgItem(IDC_HT)->EnableWindow(FALSE);
	GetDlgItem(IDC_EH)->EnableWindow(FALSE);
	GetDlgItem(IDC_K)->EnableWindow(FALSE);
	GetDlgItem(IDC_RANK)->EnableWindow(FALSE);

	GetDlgItem(IDC_RADIO_PANL)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_PANR)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_TILTU)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_TILTD)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_ZoomI)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_ZoomO)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_IRREGULAR)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_STILL)->EnableWindow(FALSE);
	GetDlgItem(IDC_DEGREE)->EnableWindow(FALSE);	
}
//------------------------------------------------------------------
int CInputDlg::constructSQLQBEJoin(CString &sql, bool execute)
{
	// the opened is the .jpg file. Open the corresponding YUV file and download 
	// the information of the Frame from it.
	int first;
	
	CFrame * frame;
	frame = new CFrame();

	CString fileName = m_fileName;
	if (g_useYUVFile)
	{
		int dotPos = fileName.ReverseFind('.');
		fileName = fileName.Mid(0,dotPos);
		fileName += ".YUV";

		if (!frame->loadFrame(fileName))
		{
			if (!frame->loadFrameFromJPG(m_fileName))
			{
				delete (frame);
				return 0;
			}
		}
	}
	else
	{
		if (!frame->loadFrameFromJPG(fileName))
		{
			delete (frame);
			return 0;
		}
	}

	// the number of results requested
	char temp[10];
	itoa(m_k,temp,10);
	CString k = (const char*) temp;
	float h[MAX_DIM];

	// construct the SQL statement
	CString select,from,cond, dist, fromMPEG;
	CString f1, f2;
	char ret[10000];
	//********************************* The query is on the shot level
	if (m_Radio_Shot.GetState())	
	{
		first = 0;
		select = "Select vs.VideoId, vs.ShotId, vs.IconFrame, vs.StartFrame, vs.EndFrame";
		from = " from VideoShot vs ";
		cond = " Where ";
		if (m_CH2)
		{
			strcpy(ret,frame->getCHHSV(h));
			f1 = (const char *) ret;
			if(execute)
			{
				sql = "insert into bar select neardist(f.CH2AVG, [vector(\"1000\")]\"p,256," + f1 + "\"," + k + ").dist() as dist from Features f;";
				g_session->execQuery(sql) ;
			}
			from += ",Features f2,bar b";
			if (first)
				cond += " and";
			first = 1;
			cond += " vs.VideoId = f2.VideoId and vs.ShotId = f2.ShotId and f2.CH2AVG.distFrom([vector(\"1000\")]\"p,256," + f1 +"\" ) <= b.dist";
		}

		if (m_CH)
		{
			strcpy(ret,frame->getCH(h));
			f1 = (const char *) ret;
			from += ",Features f1 ";
			if (first)
				cond += " and";
			else
				first = 1;
			cond += " vs.VideoId = f1.VideoId and vs.ShotId = f1.ShotId and f1.CHAVG.near([vector(\"1000\")]\"p,32," + f1 + "\"," + k + ") = 1 ";
		}

		if (m_CM)
		{
			strcpy(ret,frame->getCM(h));
			f1 = (const char *) ret;
			from+= ",Features f4";
			if (first)
				cond += " and";
			else
				first = 1;
			cond += " vs.VideoId = f4.VideoId and vs.ShotId = f4.ShotId and f4.CMAVG.near([vector(\"1000\")]\"p,2," + f1 + "\"," + k + ")=1";
		}

		if (m_TT)
		{
			strcpy(ret,frame->getTT(h));
			f1 = (const char *) ret;
			from += ",Features f5";
			if (first)
				cond += " and";
			else
				first = 1;
			cond += " vs.VideoId = f5.VideoId and vs.ShotId = f5.ShotId and f5.TTAVG.near([vector(\"1000\")]\"p,32," + f1 + "\"," + k + ")=1";
		}

		if (m_TE)
		{
			strcpy(ret,frame->getTE(h));
			f1 = (const char *) ret;
			from += ",Features f6";
			if (first)
				cond += " and";
			else
				first = 1;
			cond += " vs.VideoId = f6.VideoId and vs.ShotId = f6.ShotId and f6.TEAVG.near([vector(\"1000\")]\"p,9," + f1 + "\"," + k + ")=1";
		}

		if (m_DC)
		{
			strcpy(ret,frame->getDC());
			f1 = (const char *) ret;
			from += ",MPEGFeatures f7";
			if (first)
				cond += " and";
			else
				first = 1;
			cond += " vs.VideoId = f7.VideoId and vs.ShotId = f7.ShotId and f7.DCAVG.near([vector(\"1000\")]\"p,32," + f1 + "\"," + k + ")=1";
		}

		if (m_HT)
		{
			strcpy(ret,frame->getHT(h));
			f1 = (const char *) ret;
			from += ",MPEGFeatures f7";
			if (first)
				cond += " and";
			else
				first = 1;
			cond += " vs.VideoId = f7.VideoId and vs.ShotId = f7.ShotId and f7.HTAVG.near([vector(\"1000\")]\"p,32," + f1 + "\"," + k + ")=1";
		}

		if (m_EH)
		{
			strcpy(ret,frame->getEH(h));
			f1 = (const char *) ret;
			from += ",MPEGFeatures f7";
			if (first)
				cond += " and";
			else
				first = 1;
			cond += " vs.VideoId = f7.VideoId and vs.ShotId = f7.ShotId and f7.EHAVG.near([vector(\"1000\")]\"p,80," + f1 + "\"," + k + ")=1";
		}
	}
	//**************************** query is on the frame level but display the icon frame
	//****************** or on the frame level and display the frame
	else if (m_Radio_FrameFrame.GetState() || m_Radio_FrameShot.GetState())	
	{
		from = " from FrameFeatures x ";
		cond = " Where ";

		first = 0;
		if (m_CH2)
		{
			strcpy(ret,frame->getCHHSV(h));
			f1 = (const char *) ret;
			if(execute)
			{
				sql = "insert into bar select neardist(f.CH2, [vector(\"1000\")]\"p,256," + f1 + "\"," + k + ").dist() as dist from FrameFeatures f;";
				g_session->execQuery(sql) ;
			}
			from += ",bar b";
			if (first)
				cond += " and";
			first = 1;
			cond += " x.CH2.distFrom([vector(\"1000\")]\"p,256," + f1 +"\" ) <= b.dist";
		}
		
		if (m_CH)
		{
			strcpy(ret,frame->getCH(h));
			f1 = (const char *) ret;
			if(first) 
			{
				from += ",FrameFeatures f1";
				cond += " and x.VideoId = f1.VideoId and x.ShotId = f1.ShotId and x.FrameId = f1.FrameId and f1.CH.near([vector(\"1000\")]\"p,32," + f1 + "\"," + k + ") = 1 ";
			}
			else
			{
				first = 1;
			    cond += " x.CH.near([vector(\"1000\")]\"p,32," + f1 + "\"," + k + ") = 1 ";
			}
		}
		
		if (m_CM)
		{
			strcpy(ret,frame->getCM(h));
			f1 = (const char *) ret;
			if(first){
				from += ",FrameFeatures f4";
				cond += " and x.VideoId = f4.VideoId and x.ShotId = f4.ShotId and x.FrameId = f4.FrameId and f4.CM.near([vector(\"1000\")]\"p,2," + f1 + "\"," + k + ") = 1 ";
			}else {
				first = 1;
				cond+= " x.CM.near([vector(\"1000\")]\"p,2," + f1 + "\"," + k + ") = 1 ";
			}
		}

		if (m_TT)
		{
			strcpy(ret,frame->getTT(h));
			f1 = (const char *) ret;
			if(first){
				from += ",FrameFeatures f5";
				cond += " and x.VideoId = f5.VideoId and x.ShotId = f5.ShotId and x.FrameId = f5.FrameId and f5.TT.near([vector(\"1000\")]\"p,32," + f1 + "\"," + k + ") = 1 ";
			}else{
				first =1;
				cond+=" x.TT.near([vector(\"1000\")]\"p,32," + f1 + "\"," + k + ") = 1 ";
			}
		}

		if (m_TE)
		{
			strcpy(ret,frame->getTE(h));
			f1 = (const char *) ret;
			if(first){
				from += ",FrameFeatures f6";
				cond += " and x.VideoId = f6.VideoId and x.ShotId = f6.ShotId and  x.FrameId = f6.FrameId and f6.TE.near([vector(\"1000\")]\"p,9," + f1 + "\"," + k + ") = 1 ";
			}else {
				first =1;
				cond +=" x.TE.near([vector(\"1000\")]\"p,9," + f1 + "\"," + k + ") = 1 ";
			}
		}

		// PLEASE PUT ALL MPEG7 FEATURES AFTER THIS POINT
		if (!first)	// no feature is selected before this point i.e. no feature other than MPEG7 features are selected
			from = " from MPEGFFeatures x";
		
		if (m_DC)
		{
			strcpy(ret,frame->getDC());
			f1 = (const char *) ret;
			if (first)
			{
				from += ",MPEGFFeatures f7";
				cond += " and x.VideoId = f7.VideoId and x.ShotId = f7.ShotId and  x.FrameId = f7.FrameId and f7.DC.near([vector(\"1000\")]\"p,32," + f1 + "\"," + k + ") = 1 ";
			}
			else	// the case that x is the MPEGFFeatures table
			{
				first =1;
				cond +=" x.DC.near([vector(\"1000\")]\"p,32," + f1 + "\"," + k + ") = 1 ";
			}
		}

		if (m_HT)
		{
			strcpy(ret,frame->getHT(h));
			f1 = (const char *) ret;
			if (first)
			{
				from += ",MPEGFFeatures f7";
				cond += " and x.VideoId = f7.VideoId and x.ShotId = f7.ShotId and  x.FrameId = f7.FrameId and f7.HT.near([vector(\"1000\")]\"p,32," + f1 + "\"," + k + ") = 1 ";
			}
			else	// the case that x is the MPEGFFeatures table
			{
				first =1;
				cond +=" x.HT.near([vector(\"1000\")]\"p,32," + f1 + "\"," + k + ") = 1 ";
			}
		}

		if (m_EH)
		{
			strcpy(ret,frame->getEH(h));
			f1 = (const char *) ret;
			if (first)
			{
				from += ",MPEGFFeatures f7";
				cond += " and x.VideoId = f7.VideoId and x.ShotId = f7.ShotId and  x.FrameId = f7.FrameId and f7.EH.near([vector(\"1000\")]\"p,80," + f1 + "\"," + k + ") = 1 ";
			}
			else	// the case that x is the MPEGFFeatures table
			{
				first =1;
				cond +=" x.EH.near([vector(\"1000\")]\"p,80," + f1 + "\"," + k + ") = 1 ";
			}
		}

		if (m_Radio_FrameShot.GetState())
		{
			select = "select distinct vs.VideoId, vs.ShotId, vs.IconFrame, vs.StartFrame, vs.EndFrame";
			from += ",VideoShot vs ";
			cond += " and vs.VideoId = x.VideoId and vs.ShotId = x.ShotId";
		}
		else	// FrameFrame
		{
			select = "select x.VideoId, x.ShotId, x.FrameId, v.Movie.GetFrame(x.FrameId) ";			
			from += ", VideoStream v ";
			cond += " and v.VideoId = x.VideoId";
		}
	}
	sql = select + from + cond + ";";
		
	delete (frame);
	return 1;
}
//-------------------------------------------------------------------------------
void CInputDlg::OnRefresh() 
{
	// TODO: Add your control notification handler code here
	if (m_Radio_QyeryByExample.GetState())
	{
		UpdateData(TRUE);
		if (m_fileName != "")
		{
			Invalidate();
			UpdateWindow();
		}
	}
}
//------------------------------------------------------------------
int CInputDlg::constructSQLQBERJoin(CString &sql, bool execute)
{
	// the opened is the .jpg file. Open the corresponding YUV file and download 
	// the information of the Frame from it.
	int first;
	
	CFrame * frame;
	frame = new CFrame();

	CString fileName = m_fileName;
	if (g_useYUVFile)
	{
		int dotPos = fileName.ReverseFind('.');
		fileName = fileName.Mid(0,dotPos);
		fileName += ".YUV";

		if (!frame->loadFrame(fileName))
		{
			if (!frame->loadFrameFromJPG(m_fileName))
			{
				delete (frame);
				return 0;
			}
		}
	}
	else
	{
		if (!frame->loadFrameFromJPG(fileName))
		{
			delete (frame);
			return 0;
		}
	}

	// the number of results requested
	char temp[10];
	itoa(m_k,temp,10);
	CString k = (const char*) temp;
	float h[MAX_DIM];

	// construct the SQL statement
	CString select,from,cond, dist,prevTable, order, select2, rank;
	CString f1, f2;
	char ret[10000];

	from = cond = prevTable = "";
	order = " order by ";
	first = 0;
	
	//************************************ the query is on the shot level
	if (m_Radio_Shot.GetState())	
	{
		select = "Select vs.VideoId, vs.ShotId, vs.IconFrame, vs.StartFrame, vs.EndFrame ";

		if (m_CH2)
		{
			strcpy(ret,frame->getCHHSV(h));
			f1 = (const char *) ret;
			if (execute)
			{
				sql = " insert into SeqTemp select * from (select f.VideoId,f.ShotId, 0 as FrameId, (10- f.CH2AVG.distFrom([vector(\"1000\")]\"p,256," + f1 + "\"))/10 as dist from Features f) as t order by dist desc;";
				g_session->execQuery(sql) ;
			}
			if (first==1)
				cond += " Where "; 
			else if (first)
				cond += " and ";

			if (first)
			{
				from += ",";
				order += ",";
				rank += "+";
				cond += prevTable + ".VideoId = t0.VideoId and " + prevTable + ".ShotId = t0.ShotId";
			}
			else
				select2 = " t0.VideoId,t0.ShotId,";
			
			from += " (select VideoId, ShotId, dist from SeqTemp) as t0";
			order += "t0.dist";
			rank += "t0.dist";
			prevTable = "t0";
			first ++;
		}

		if (m_TT)
		{
			strcpy(ret,frame->getTT(h));
			f1 = (const char *) ret;
			if (first==1)
				cond += " Where "; 
			else if (first)
				cond += " and ";
			
			if (first)
			{
				from += ",";
				order += ",";
				rank += "+";
				cond += prevTable + ".VideoId = t3.VideoId and " + prevTable + ".ShotId = t3.ShotId";
			}
			else
				select2 = " t3.VideoId,t3.ShotId,";
			
			from += " (select f.VideoId,f.ShotId,(500- f.TTAVG.distFrom([vector(\"1000\")]\"p,32," + f1 + "\"))/500 as dist from Features f where f.TTAVG.near([vector(\"1000\")]\"p,32," + f1 + "\",0) = 1) as t3";
			order += "t3.dist";
			rank += "t3.dist";
			prevTable = "t3";
			first ++;
		}

		if (m_TE)
		{
			strcpy(ret,frame->getTE(h));
			f1 = (const char *) ret;
			if (first==1)
				cond += " Where "; 
			else if(first)
				cond += " and ";
			
			if (first)
			{
				from += ",";
				order += ",";
				rank += "+";
				cond += prevTable + ".VideoId = t4.VideoId and " + prevTable + ".ShotId = t4.ShotId";
			}
			else
				select2 = " t4.VideoId,t4.ShotId,";
			
			from += " (select f.VideoId,f.ShotId,(2 - f.TEAVG.distFrom([vector(\"1000\")]\"p,9," + f1 + "\"))/2 as dist from Features f where f.TEAVG.near([vector(\"1000\")]\"p,9," + f1 + "\",0) = 1) as t4";
			order += "t4.dist";
			rank += "t4.dist";
			prevTable = "t4";
			first ++;
		}

		if (m_CH)
		{
			strcpy(ret,frame->getCH(h));
			f1 = (const char *) ret;
			if (first==1)
				cond += " Where "; 
			else if(first)
				cond += " and ";
			
			if (first)
			{
				from += ",";
				order += ",";
				rank += "+";
				cond += prevTable + ".VideoId = t1.VideoId and " + prevTable + ".ShotId = t1.ShotId";
			}
			else
				select2 = " t1.VideoId,t1.ShotId,";

			from += " (select f.VideoId,f.ShotId,(2- f.CHAVG.distFrom([vector(\"1000\")]\"p,32," + f1 + "\"))/2 as dist from Features f where f.CHAVG.near([vector(\"1000\")]\"p,32," + f1 + "\",0)=1) as t1";
			order += "t1.dist";
			rank += "t1.dist";
			prevTable = "t1";
			first++;
		}

		if (m_CM)
		{
			strcpy(ret,frame->getCM(h));
			f1 = (const char *) ret;
			if (first==1)
				cond += " Where "; 
			else if (first)
				cond += " and ";

			if (first)
			{
				from += ",";
				order += ",";
				rank += "+";
				cond += prevTable + ".VideoId = t2.VideoId and " + prevTable + ".ShotId = t2.ShotId";
			}
			else
				select2 = " t2.VideoId,t2.ShotId,";
			
			from += " (select f.VideoId,f.ShotId,(500- f.CMAVG.distFrom([vector(\"1000\")]\"p,2," + f1 + "\"))/500 as dist from Features f where f.CMAVG.near([vector(\"1000\")]\"p,2," + f1 + "\",0) = 1) as t2";
			order += "t2.dist";
			rank += "t2.dist";
			prevTable = "t2";
			first ++;
		}
		
		if (m_DC)
		{
			strcpy(ret,frame->getDC());
			f1 = (const char *) ret;
			if (first==1)
				cond += " Where "; 
			else if(first)
				cond += " and ";
			
			if (first)
			{
				from += ",";
				order += ",";
				rank += "+";
				cond += prevTable + ".VideoId = t5.VideoId and " + prevTable + ".ShotId = t5.ShotId";
			}
			else
				select2 = " t5.VideoId,t5.ShotId,";
			
			from += " (select f.VideoId,f.ShotId,(2 - f.DCAVG.distFrom([vector(\"1000\")]\"p,32," + f1 + "\"))/2 as dist from MPEGFeatures f where f.DCAVG.near([vector(\"1000\")]\"p,32," + f1 + "\",0) = 1) as t5";
			order += "t5.dist";
			rank += "t5.dist";
			prevTable = "t5";
			first ++;
		}

		if (m_HT)
		{
			strcpy(ret,frame->getHT(h));
			f1 = (const char *) ret;
			if (first==1)
				cond += " Where "; 
			else if(first)
				cond += " and ";
			
			if (first)
			{
				from += ",";
				order += ",";
				rank += "+";
				cond += prevTable + ".VideoId = t6.VideoId and " + prevTable + ".ShotId = t6.ShotId";
			}
			else
				select2 = " t6.VideoId,t6.ShotId,";
			
			from += " (select f.VideoId,f.ShotId,(100000 - f.HTAVG.distFrom([vector(\"1000\")]\"p,32," + f1 + "\"))/100000.0 as dist from MPEGFeatures f where f.HTAVG.near([vector(\"1000\")]\"p,32," + f1 + "\",0) = 1) as t6";
			order += "t6.dist";
			rank += "t6.dist";
			prevTable = "t6";
			first ++;
		}
		
		if (m_EH)
		{
			strcpy(ret,frame->getEH(h));
			f1 = (const char *) ret;
			if (first==1)
				cond += " Where "; 
			else if(first)
				cond += " and ";
			
			if (first)
			{
				from += ",";
				order += ",";
				rank += "+";
				cond += prevTable + ".VideoId = t7.VideoId and " + prevTable + ".ShotId = t7.ShotId";
			}
			else
				select2 = " t7.VideoId,t7.ShotId,";
			
			from += " (select f.VideoId,f.ShotId,(16 - f.EHAVG.distFrom([vector(\"1000\")]\"p,80," + f1 + "\"))/16 as dist from MPEGFeatures f where f.EHAVG.near([vector(\"1000\")]\"p,80," + f1 + "\",0) = 1) as t7";
			order += "t7.dist";
			rank += "t7.dist";
			prevTable = "t7";
			first ++;
		}
		
		select2 += rank + " as rank rjoin ";
		from = " from (select " + select2 + from;
		if (m_rank)
			cond += order;	// consider the order by t1+t2+.. tn otherwise don't consider the order by
		from += cond + " stop after " + k + ") as y, VideoShot vs where y.VideoId=vs.VideoId and y.ShotId = vs.ShotId";
		sql = select + from + " order by y.rank desc;";
	}
	//************************************ query the frame level and display the frame 
	// (use Frame Features table with the VideoStream Directly)
	//************************************ query the frame level and display the shot
	// Work on the FrameFeatures and VideoShots
	else if (m_Radio_FrameFrame.GetState() || m_Radio_FrameShot.GetState())	
	{
		if (m_Radio_FrameFrame.GetState())
			select = "Select y.VideoId, y.ShotId, y.FrameId, v.Movie.GetFrame(y.FrameId) ";
		else
		{
			select = "Select g.VideoId, g.ShotId, g.IconFrame, g.StartFrame, g.EndFrame from (";
			select += "select  VideoId, ShotId ,StartFrame, EndFrame, max(Rank) as maxdist,IconFrame ";
		}

		if (m_CH2)
		{
			strcpy(ret,frame->getCHHSV(h));
			f1 = (const char *) ret;
			if (execute)
			{
				sql = " insert into SeqTemp select * from (select f.VideoId,f.ShotId, f.FrameId, (10- f.CH2.distFrom([vector(\"1000\")]\"p,256," + f1 + "\"))/10 as dist from FrameFeatures f) as t order by dist desc;";
				g_session->execQuery(sql) ;
			}
			if (first==1)
				cond += " Where "; 
			else if (first)
				cond += " and ";

			if (first)
			{
				from += ",";
				order += ",";
				rank += "+";
				cond += prevTable + ".VideoId = t0.VideoId and " + prevTable + ".FrameId = t0.FrameId";
			}
			else
				select2 = " t0.VideoId,t0.ShotId,t0.FrameId,";
			
			from += " (select VideoId,ShotId,FrameId,dist from SeqTemp)  as t0";
			order += "t0.dist";
			rank += "t0.dist";
			prevTable = "t0";
			first ++;
		}

		if (m_TT)
		{
			strcpy(ret,frame->getTT(h));
			f1 = (const char *) ret;
			if (first==1)
				cond += " Where "; 
			else if (first)
				cond += " and ";
			
			if (first)
			{
				from += ",";
				order += ",";
				rank += "+";
				cond += prevTable + ".VideoId = t3.VideoId and " + prevTable + ".FrameId = t3.FrameId";
			}
			else
				select2 = " t3.VideoId,t3.ShotId,t3.FrameId,";
			
			from += " (select f.VideoId,f.ShotId, f.FrameId,(500- f.TT.distFrom([vector(\"1000\")]\"p,32," + f1 + "\"))/500 as dist from FrameFeatures f where f.TT.near([vector(\"1000\")]\"p,32," + f1 + "\",0) = 1) as t3";
			order += "t3.dist";
			rank += "t3.dist";
			prevTable = "t3";
			first ++;
		}

		if (m_TE)
		{
			strcpy(ret,frame->getTE(h));
			f1 = (const char *) ret;
			if (first==1)
				cond += " Where "; 
			else if(first)
				cond += " and ";
			
			if (first)
			{
				from += ",";
				order += ",";
				rank += "+";
				cond += prevTable + ".VideoId = t4.VideoId and " + prevTable + ".FrameId = t4.FrameId";
			}
			else
				select2 = " t4.VideoId,t4.ShotId,t4.FrameId,";
			
			from += " (select f.VideoId,f.ShotId, f.FrameId,(2 - f.TE.distFrom([vector(\"1000\")]\"p,9," + f1 + "\"))/2 as dist from FrameFeatures f where f.TE.near([vector(\"1000\")]\"p,9," + f1 + "\",0) = 1) as t4";
			order += "t4.dist";
			rank += "t4.dist";
			prevTable = "t4";
			first ++;
		}

		if (m_CH)
		{
			strcpy(ret,frame->getCH(h));
			f1 = (const char *) ret;
			if (first==1)
				cond += " Where "; 
			else if(first)
				cond += " and ";
			
			if (first)
			{
				from += ",";
				order += ",";
				rank += "+";
				cond += prevTable + ".VideoId = t1.VideoId and " + prevTable + ".FrameId = t1.FrameId";
			}
			else
				select2 = " t1.VideoId,t1.ShotId,t1.FrameId,";
			

			from += " (select f.VideoId,f.ShotId, f.FrameId, (2- f.CH.distFrom([vector(\"1000\")]\"p,32," + f1 + "\"))/2 as dist from FrameFeatures f where f.CH.near([vector(\"1000\")]\"p,32," + f1 + "\",0)=1) as t1";
			order += "t1.dist";
			rank += "t1.dist";
			prevTable = "t1";
			first++;
		}

		if (m_CM)
		{
			strcpy(ret,frame->getCM(h));
			f1 = (const char *) ret;
			if (first==1)
				cond += " Where "; 
			else if (first)
				cond += " and ";

			if (first)
			{
				from += ",";
				order += ",";
				rank += "+";
				cond += prevTable + ".VideoId = t2.VideoId and " + prevTable + ".FrameId = t2.FrameId";
			}
			else
				select2 = " t2.VideoId,t2.ShotId,t2.FrameId,";
			
			from += " (select f.VideoId,f.ShotId, f.FrameId,(500- f.CM.distFrom([vector(\"1000\")]\"p,2," + f1 + "\"))/500 as dist from FrameFeatures f where f.CM.near([vector(\"1000\")]\"p,2," + f1 + "\",0) = 1) as t2";
			order += "t2.dist";
			rank += "t2.dist";
			prevTable = "t2";
			first ++;
		}

		if (m_DC)
		{
			strcpy(ret,frame->getDC());
			f1 = (const char *) ret;
			if (first==1)
				cond += " Where "; 
			else if(first)
				cond += " and ";
			
			if (first)
			{
				from += ",";
				order += ",";
				rank += "+";
				cond += prevTable + ".VideoId = t5.VideoId and " + prevTable + ".FrameId = t5.FrameId";
			}
			else
				select2 = " t5.VideoId,t5.ShotId,t5.FrameId,";
			
			from += " (select f.VideoId,f.ShotId, f.FrameId,(2 - f.DC.distFrom([vector(\"1000\")]\"p,32," + f1 + "\"))/2 as dist from MPEGFFeatures f where f.DC.near([vector(\"1000\")]\"p,32," + f1 + "\",0) = 1) as t5";
			order += "t5.dist";
			rank += "t5.dist";
			prevTable = "t5";
			first ++;
		}

		if (m_HT)
		{
			strcpy(ret,frame->getHT(h));
			f1 = (const char *) ret;
			if (first==1)
				cond += " Where "; 
			else if(first)
				cond += " and ";
			
			if (first)
			{
				from += ",";
				order += ",";
				rank += "+";
				cond += prevTable + ".VideoId = t6.VideoId and " + prevTable + ".FrameId = t6.FrameId";
			}
			else
				select2 = " t6.VideoId,t6.ShotId,t6.FrameId,";
			
			from += " (select f.VideoId,f.ShotId, f.FrameId,(100000 - f.HT.distFrom([vector(\"1000\")]\"p,32," + f1 + "\"))/100000 as dist from MPEGFFeatures f where f.HT.near([vector(\"1000\")]\"p,32," + f1 + "\",0) = 1) as t6";
			order += "t6.dist";
			rank += "t6.dist";
			prevTable = "t6";
			first ++;
		}
		
		if (m_EH)
		{
			strcpy(ret,frame->getEH(h));
			f1 = (const char *) ret;
			if (first==1)
				cond += " Where "; 
			else if(first)
				cond += " and ";
			
			if (first)
			{
				from += ",";
				order += ",";
				rank += "+";
				cond += prevTable + ".VideoId = t7.VideoId and " + prevTable + ".FrameId = t7.FrameId";
			}
			else
				select2 = " t7.VideoId,t7.ShotId,t7.FrameId,";
			
			from += " (select f.VideoId,f.ShotId, f.FrameId,(16 - f.EH.distFrom([vector(\"1000\")]\"p,80," + f1 + "\"))/16 as dist from MPEGFFeatures f where f.EH.near([vector(\"1000\")]\"p,80," + f1 + "\",0) = 1) as t7";
			order += "t7.dist";
			rank += "t7.dist";
			prevTable = "t7";
			first ++;
		}
		

		if (m_rank)
			cond += order;	// consider the order by t1+t2+.. tn otherwise don't consider the order by

		if (m_Radio_FrameFrame.GetState())
		{
			select2 += rank + " as rank rjoin ";
			from = " from (select " + select2 + from;
			from += cond + " stop after " + k + ") as y, VideoStream v where y.VideoId=v.VideoId";
			sql = select + from + " order by y.rank desc;";
		}
		else
		{
			select2 += rank + " as Rank rjoin ";
			from = " from (select " + select2 + from;
			from += cond + " stop after " + k + ") as y, VideoShot vs where y.VideoId=vs.VideoId and y.ShotId = vs.ShotId";
			sql = select + from + " group by VideoId, ShotId, StartFrame, EndFrame, IconFrame ) as g  order by g.maxdist desc;";
		}
	}
		
	delete (frame);
	return 1;
}
//----------------------------------------------------------
int CInputDlg::getTypeOfQBEJoin()
{
	// return 1 if normal join is needed i.e. one feature in the query or more 
	// than one feature and one of them is not indexed
	int features=0;

	if (m_MH)
	{				
		AfxMessageBox("Motion Histogram can't be used where the query is with a still image");
		return 0;
	}

	if (m_SC)
	{				
		AfxMessageBox("Scalable Color is used when you have a color histogram with a dimension greater than the one saved in the DB");
		return 0;
	}
		
	if (m_CH)
		features++;

	if (m_CH2)
		features++;

	if (m_CM)
		features ++;

	if (m_TT)
		features++;

	if (m_TE)
		features++;

	if (m_DC)
		features++;

	if (m_HT)
		features++;

	if (m_EH)
		features++;

	if (!features)
	{
		AfxMessageBox("Please select at least one feature for the query");
		return 0;
	}
	else if (features == 1)	// all are indexed features
		return 1;	// use normal join because only one feature is used
	else
		return 2;	// use RJOIN - more than one feature is used
}

void CInputDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	
}
