

//SMostafa: for Visual c++ threading
//#include "stdafx.h"
//EMostafa
#include "stdafx.h"
#include <afxtempl.h>
#include "predconnect.h"
#include <process.h>
#include <sys/time.h>

#include "WinClient/cursorRecord.h"
CArray <CursorRecord*, CursorRecord*> g_cursor;
FILE * g_pTempImageFile;
//
// Methods of PredConnection
//
//SMostafa: play with threading

UINT MyThreadProc( LPVOID pParam )
{
    char* pObject = (char*)pParam;

    if (pObject == NULL)// || pObject->IsKindOf(RUNTIME_CLASS(char*)))
    return 1;   // if pObject is not valid

    // do something with 'pObject'
	system(pObject);
    return 0;   // thread completed successfully
}
//SMostafa
//EMostafa


const char *PredConnection::initString = "NEW SESSION\n";
PredConnection::PredConnection(const char* HostName, int PortNumber,
			       const char* UserName, const char* Password,
			       bool Binary, bool GetSchemas)
{
 init();
 binaryMode = Binary;
 getSchemas = GetSchemas;
 portNumber = PortNumber;
 hostName = new char[strlen(HostName)+1];
 strcpy(hostName, HostName);
 userName = new char[strlen(UserName)+1];
 strcpy(userName, UserName);
 password = new char[strlen(Password)+1];
 strcpy(password, Password);

 socket = new XxxSocketConnection(hostName, portNumber);
 if (!socket->Valid()) {
   cerr << "Did not make connection to server" << endl;
   return;
  }

 // set up protocol
 if (!setupProtocol()) {
   cerr << "Could not set up protocol" << endl;
   return;
  }
 valid = true;
}

PredConnection::~PredConnection()
{
 // expect the server to close out the protocol with a \0
 if (valid) {
   if (!terminateProtocol()) {
     cerr << "No clean shutdown from server" << endl;
    }
  }
 reclaim();
}

int PredConnection::setupProtocol()
{
 if (!socket) {
   cerr << "Invalid connection" << endl;
   return 0;
  }
 int SocketDesc = socket->socketDesc;
 // Send the string which requests a new client session
 if (::send(SocketDesc, initString, strlen(initString),0) != strlen(initString)) {
   cerr << "Bad send" << endl;
   return 0;
 }

 char Buf[500];
 int BytesRead;

 if ((BytesRead = ::recv(SocketDesc, Buf, 500, 0)) <= 0) {
   cerr << "Bad Read" << endl;
   return 0;
  }
 if (strncmp(Buf, "Setup?\n", BytesRead)) {
   cerr << "Unexpected protocol string from server:" << Buf << endl;
   cerr << "Bytes Read: " << BytesRead << endl;
   return 0;
  }
 // TODO: We want to modify this to NOT use 'txtclient' method of interfacing
 // this is because is is textual and we want binary for enhanced control over
 // the data returned by the server.

 // now send back a string with initial info
 sprintf (Buf, "%s %s %s ", userName, password, // passwd
	  "txtclient"); // protocolname
 if (::send(SocketDesc, Buf, strlen(Buf)+1, 0) != strlen(Buf)+1) {
   cerr << "Bad send" << endl;
   return 0;
 }

 // now handshake on the options
 if ((BytesRead = ::recv(SocketDesc, Buf, 500, 0)) <= 0) {
   cerr << "Bad Read" << endl;
   return 0;
  }
 if (strncmp(Buf, "Options?\n", BytesRead)) {
   cerr << "Unexpected protocol string from server:" << Buf << endl;
   cerr << "Bytes Read: " << BytesRead << endl;
   return 0;
  }
 sprintf (Buf, "-s %d -b %d", (getSchemas?1:0), (binaryMode?1:0));
 if (::send(SocketDesc, Buf, strlen(Buf), 0) != strlen(Buf)) {
   cerr << "Bad send" << endl;
   return 0;
 }

 // now get back a "good" or a "bad"
 if ((BytesRead = ::recv(SocketDesc, Buf, 500, 0)) <= 0) {
   cerr << "Bad Read" << endl;
   return 0;
  }
 if (!strncmp(Buf, "good", BytesRead))
   return 1;
 else {
   cerr << "Setup failed at server" << endl;
   return 0;
  }
}

bool PredConnection::requestTerminated(const char*Buf, int BytesRead) const
{
 if (!valid) {
   cerr << "Invalid connection" << endl;
   return true;
  }
 // answers terminated by \0

 if (!Buf[BytesRead-1]) { 
   return true;
  }
 return false;
}

int PredConnection::terminateProtocol()
{
 if (!valid) {
   cerr << "Invalid connection" << endl;
   return 0;
  }
 int SocketDesc = socket->socketDesc;
 char Buf[100];
 int BytesToRead = 0; // signal EOF
 if (::send(SocketDesc, (char*)&BytesToRead, sizeof(BytesToRead), 0) !=
     sizeof(BytesToRead)) {
   cerr << "Bad send" << endl;
   return 0;
 }

 if (::recv(SocketDesc, Buf, 100, 0) <= 0) {
   cerr << "Bad recv" << endl;
   return 0;
  }
 return 1;
}

int PredConnection::SendRequest(const char* Buf)
{
 if (!valid) {
   cerr << "Invalid connection" << endl;
   return 0;
  }
 int SocketDesc = socket->socketDesc;
 // first send the length
 int BufLength = strlen(Buf)+1;
 int NetworkBufLength = htonl(BufLength);
 if (::send(SocketDesc, (char*)&NetworkBufLength, sizeof(int), 0) != sizeof(int)) {
   cerr << "Error writing data length" << endl;
   valid = false;
   return 0;
  }
 // then send the data
 if (::send(SocketDesc, Buf, strlen(Buf)+1, 0) != (int)(strlen(Buf)+1)) {
   cerr << "Error writing data" << endl;
   valid = false;
   return 0;
  }
 return 1;
}

int PredConnection::PrintReply(ostream& OStr)
{
 
 clock_t Time;
 if (!valid) {
   cerr << "Invalid connection" << endl;
   return 0;
  }
 int SocketDesc = socket->socketDesc;
 char Buf[RESULT_BUFFER_MAX+1];
 int BytesRead;

 //SMostafa
 int *recSize, totalRead = 0; bool readThisMuch=false;
 FILE *myfile; 
 char *TmpName;
 //char FileName[30];
 char fileName[100];

 //strcpy(FileName,"h:\\mhammad");
 //TmpName = (FileName+10);
 //tmpnam(TmpName);
 //strcat(TmpName, "mpeg");					
 //EMostafa

 Time = clock();
 
 while (1) {
   BytesRead = ::recv(SocketDesc, Buf, RESULT_BUFFER_MAX, 0);
   if (BytesRead <= 0) {
     perror("Server error:");
     valid = 0;
     return 0;
   }
   Buf[BytesRead] = 0;

   if(!readThisMuch){	// A flag set afer getting the file size
	char *sizePtr, *tmpStr;
	char sizeStr[100]; int cnt = 0;
	char tmpSizeStr[100]; int tmpCnt = 0;
	if ((sizePtr = strchr(Buf,'@'))!=NULL){
		//SMostafa: get the record size   I encapsulate the size between two @s
		// *********** File is sent as stream of bits ******************
		int offset = sizePtr - Buf;
		// get file size
		sizePtr++;	
		while (*sizePtr!='@'){		
			sizeStr[cnt++] = *sizePtr; sizePtr++;
		}
		//SMostafa:Since server is behind UNIX Arch	thn has to switch work
		while(tmpCnt<cnt){			
			tmpSizeStr[0+tmpCnt]=sizeStr[3+tmpCnt];
			tmpSizeStr[1+tmpCnt]=sizeStr[2+tmpCnt];
			tmpSizeStr[2+tmpCnt]=sizeStr[1+tmpCnt];
			tmpSizeStr[3+tmpCnt]=sizeStr[0+tmpCnt];
			tmpCnt = tmpCnt + 4;
		}
		recSize = (int *)tmpSizeStr;	
		//EMostafa
		//recSize = (int *)sizeStr;	
		readThisMuch = true;
		// output the rest of the message
		totalRead = BytesRead - cnt - 2 ;				
		Buf[offset]='\0';
		OStr << Buf;
		OStr << flush;
	}   
	else if ((sizePtr = strchr(Buf,'^'))!=NULL){
		// *********** File is sent as stream of bits to store locally on the client *************
		// store the file
		int offset = sizePtr - Buf;
		// get file size
		sizePtr++;	
		while (*sizePtr!='^'){		
			sizeStr[cnt++] = *sizePtr; sizePtr++;
		}
		
		strncpy(fileName, sizeStr,cnt);
		fileName[cnt]=0x0;
		int totalCnt = cnt;
		cnt = 0;	
		sizePtr++;	
		while (*sizePtr!='^'){		
			sizeStr[cnt++] = *sizePtr; sizePtr++;
		}
		//SMostafa:Since server is behind UNIX Arch	thn has to switch work
		while(tmpCnt<cnt){			
			tmpSizeStr[0+tmpCnt]=sizeStr[3+tmpCnt];
			tmpSizeStr[1+tmpCnt]=sizeStr[2+tmpCnt];
			tmpSizeStr[2+tmpCnt]=sizeStr[1+tmpCnt];
			tmpSizeStr[3+tmpCnt]=sizeStr[0+tmpCnt];
			tmpCnt = tmpCnt + 4;
		}
		recSize = (int *)tmpSizeStr;	
		//EMostafa
		//recSize = (int *)sizeStr;	
		readThisMuch = true;
		// output the rest of the message
		totalCnt = totalCnt + cnt;
		totalRead = BytesRead - totalCnt - 3 ;				
		Buf[offset]='\0';
		OStr << Buf;
		OStr << flush;
		//SMostafa : (Ex)just  write to disk		
		myfile = fopen(fileName, "wb");
		if(!myfile){
			OStr << " Error with the supplied file name" << endl;
			return 0;
		}
		write(fileno(myfile), Buf+totalCnt+3+offset, BytesRead - totalCnt - 4);		
		
	}
	else{ 
		// *********** File is sent as URL ******************
		if ((sizePtr = strstr(Buf,"http"))!=NULL){			
			char VPlayer[1024] = "h:\\predator\\wmplayer.exe ";						
			strcat(VPlayer, sizePtr);
			// SMostafa: make this run as another thread			
			AfxBeginThread(MyThreadProc, VPlayer);
			// EMostafa:	
		}
		/*
		else{
		*/
		OStr << Buf;
		OStr << flush;
		if (requestTerminated(Buf, BytesRead))
		  break;
	}
   }
   else{
	   // new stopping criteria
	   totalRead+= BytesRead;
	   //SMostafa : (Ex)just write to disk
	   if(myfile)
		write(fileno(myfile), Buf, BytesRead);		   
	   else{
		// You should stream the content throught a player in this part of the code
	   };	   
	   if(totalRead>*recSize) { 
			OStr << " TransferRate = ";
			#ifdef XXX_WIN32
				clock_t NewTime = clock();
				int tt = (totalRead / (double)(NewTime - Time) ) * CLOCKS_PER_SEC * 8; 
				OStr << tt;
			#else
				struct timeval NewTime;
				struct timezone Temp;
				gettimeofday(&NewTime, &Temp);
				 OStr << totalRead / (NewTime.tv_sec-Time.tv_sec)+(NewTime.tv_usec-Time.tv_usec)/1000000.0;
			#endif
			OStr << " bits/sec" << endl;
			//SMostafa : (Ex)just write to disk
			if(myfile)
				fclose(myfile); 						
			char fullFileName[80];			
			readThisMuch = false;
			break;
	   }
   }
   //EMostafa
   
  } // while (1)
 return 1;
}





ReplyScan* PredConnection::CreateReplyScan()
{
 if (!valid) {
   cerr << "Invalid connection" << endl;
   return NULL;
  }
 int SocketDesc = socket->socketDesc;
 char Buf[RESULT_BUFFER_MAX+1];
 int BytesRead;
 ReplyScan* replyScan = new ReplyScan();

 while (1) {
   BytesRead = ::recv(SocketDesc, Buf, RESULT_BUFFER_MAX, 0);
   if (BytesRead <= 0) {
     perror("Server error:");
     valid = 0;
     return NULL;
    }
   Buf[BytesRead] = 0;
   replyScan->AnsOStr << Buf;

   if (requestTerminated(Buf, BytesRead))
     break;
  } // while (1)
 replyScan->init();
 return replyScan;
}


bool PredConnection::CreateBufferScan(char* Buffer, bool &TimeOut, bool &AtEnd)
{
 if (!valid) {
   cerr << "Invalid connection" << endl;
   return false;
  }
 int SocketDesc = socket->socketDesc;
 char Buf[RESULT_BUFFER_MAX+1];
 int BytesRead;

 const struct timeval Timeout = {0,50}; // 1 seconds time-out
 fd_set ReadSockets;
 FD_ZERO(&ReadSockets);
 FD_SET(SocketDesc, &ReadSockets);

 // wait until a proxy server sends data
 int selval = select(1, &ReadSockets, NULL, NULL, &Timeout);
		
 if (selval < 0) {
	 return false;
 } else if (selval == 0) {
	 // time out
	 strcpy(Buffer, "<I></I>");
	 TimeOut = true;
	 AtEnd = false;
	 return true;

 } else {
	TimeOut = false;
	BytesRead = ::recv(SocketDesc, Buf, RESULT_BUFFER_MAX, 0);
	if (BytesRead <= 0) {
		perror("Server error:");
		valid = 0;
		return false;
	}
	Buf[BytesRead] = 0;

	if (requestTerminated(Buf, BytesRead)) {
		AtEnd = true;
	} else {
		AtEnd = false;
	}
	 
	strcpy(Buffer, Buf);
	return true;
 }

}





ReplyScan::ReplyScan()
{
  ptr = NULL;
  atEnd = true;
  PrintedAlready = false;
}

ReplyScan::~ReplyScan()
{
  if (ptr) delete [] ptr;
}

void ReplyScan::init()
{
  ptr = AnsOStr.str();
  ptr[AnsOStr.pcount()] = 0;
  if (!(*ptr)) {
    atEnd = true;
  }else{
    atEnd = false;
  }
}

char ReplyScan::GetNextChar()
{
  return(*ptr++);
  PrintedAlready = true;
}

bool ReplyScan::IsError()
{
  char *where = strstr(ptr, "Error: Error processing user request");
  if(!where)   return false;
  return true;
}

bool ReplyScan::AnyResults()
{
  char *where = strchr(ptr, '\t');
  if(!where)   return false;
  return true;
}

void ReplyScan::PrintSchema(ostream& OStr)
{
  char *where1 = strchr(ptr, '<');
  char *where2 = strchr(ptr, '>');
  char *where3 = strchr(ptr, ':');
  if (!PrintedAlready && where1 && where2 && where3) {
    PrintedAlready = true;
    while ((*ptr != '<') && (*ptr)) ptr++; // gets you to the first char safely
    if (!(*ptr)) {
      OStr << "<td><center><b>SOMETHING WRONG</B></CENTER></TD>"<< endl;
      return;
    }
    OStr << "<td><center><font size+=2 color = \"red\"><b>";
    ptr++;
    bool InParen = false;
    while (*ptr) { // loop through the stream, printing out the schema
      if (*ptr == '>') {
	OStr << "</b></font></center></td>";
	ptr++;
	break;
      }
      if (*ptr == '(') {
	InParen = true;
      }
      if (*ptr == ')') {
	InParen = false;
      }
      if (*ptr == ',' && !InParen) {
	OStr << "</b></font></center></td><td><center><font size+=2 color = \"red\"><b>";
	ptr++;
      } 
      else {
	OStr << *ptr++;
      }
    } // while
  } // for
}
// Answers come back separated by tabs, so the functions following GetNextItem
// show how messy it is to use a textual interface to PREDATOR.  Make it binary
// and this code cleans up very, very quickly.
int ReplyScan::GetNextItem(char* first)
{
  PrintedAlready = true;
  char *where = strchr(ptr, '\t');
  if(!where)   return 0;
  strncpy(first,ptr,where-ptr);
  first[where-ptr] = 0;
  ptr += (where-ptr+1);
  if (!(*ptr)) {
    atEnd = true;
  }else{
    atEnd = false;
  }
  return 1;
}

void ReplyScan::GetNextLine(ostream& OStr)
{
  PrintedAlready = true;
  if(!(*ptr)){
    atEnd = true;
  }else{
    bool hitQuote = false;
    while (1) {
      if(!(*ptr)){
	atEnd = true;
	OStr << 0;
	break;
      }
      if((*ptr == '\n') && (!hitQuote)) {
	OStr << 0;
	break;
      }
      if((*ptr == '\t') && (!hitQuote)){
      }else{
	if(*ptr == '\"'){
	  hitQuote = !hitQuote;
	}else{
	  OStr.put(*ptr);
	}
      }
      ptr++;
    }
    ptr++;
  }
}

void ReplyScan::GetNextLineFormatted(ostream& OStr)
{
  PrintedAlready = true;
  if (!(*ptr)) {
    atEnd = true;
  } 
  else {
    bool hitQuote = false;
    bool firstTime = true;
    bool printTD = false;
    while (1) {
      if (!(*ptr)) {
	atEnd = true;
	break;
      }
      if ((*ptr == '\n') && !hitQuote) {
	break;
      }
      if ((*ptr == '\t') && !hitQuote){
	printTD = true;
      } 
      else {
	if ((printTD) && !firstTime) {
	  OStr << "</CENTER><TD><CENTER>";
	  printTD = false;
	}
	if (firstTime) {
	  OStr << "<TD><CENTER>";
	  firstTime = false;
	}
	if ((*ptr == 'h') && (*(ptr+1) == 't') && (*(ptr+2) == 't' ) && (*(ptr+3) == 'p') && (*(ptr+4) == ':') && (*(ptr+5) == '/') && (*(ptr+6) == '/')) {
	  OStr << "<A TARGET=\"Document\" HREF=\"";
	  while((*ptr != '\t') && (*ptr != '\n') && (*ptr)) {
	    OStr.put(*ptr);
	    ptr++;
	  }
	  OStr << "\">View</A></CENTER><TD><CENTER>";
	} // if http value
	else{
	  if (*ptr == '\"') {
	    hitQuote = !hitQuote;
	  }
	  else{
	    OStr.put(*ptr);
	  }
	} // else if not http value
      } // else if !((*ptr == '\t') && (!hitQuote))
      ptr++;
      firstTime = false;
    }// while(1)
    ptr++;
    firstTime = false;
  }
}
//------------------------------------------------------------
int PredConnection::saveReply()
{
	// data structure to save the reply

	if (!valid) 
		return ERRINVALIDCON;
	
	struct FIELD{
		int size;
		void *content;
	} tempField;

	struct SCHEMA	{
		int type;
		char fieldName[FIELD_NAME_SIZE];
	} schema[MAX_NO_FIELDS];


	int socketDesc = socket->socketDesc;
	char buf[RESULT_BUFFER_MAX+1];
	int bytesRead;

	BOOL schemaRead , fieldOk, incompleteField ;
	char *tempPtr ; char *crtPtr;
	int crtField, crtRow, size,currentSize, noOfFields;
	CursorRecord * record;

	schemaRead = fieldOk = incompleteField = 0;
	crtField = crtRow = noOfFields = 0;
	record =  new CursorRecord;

	while (1) 
	{
		bytesRead = ::recv(socketDesc, buf, RESULT_BUFFER_MAX, 0);
		if (bytesRead <= 0) 
		{
			perror("Server error:");
			valid = 0;
			delete (record);
			return ERR0BYTE;
		}
		buf[bytesRead] = 0;
		crtPtr = buf;
				
		// read the header and fill in the schema only once.
		if (!schemaRead)
		{
			if (strchr(buf,'<')!=&buf[0])
			{
				delete (record);
				while(!requestTerminated(buf,bytesRead))
					bytesRead = ::recv(socketDesc, buf, RESULT_BUFFER_MAX, 0);
				return ERRSYNTAX;	// the buffer should start with < to be correct
			}

			if ((tempPtr=strchr(buf,'>'))!=NULL)	// all the schema is in this buffer
			{
				crtPtr = (strchr(buf,'<'))+1;

				char * temp2Ptr;
				char fieldType[20];

				while (temp2Ptr != tempPtr)
				{
					temp2Ptr = strchr(crtPtr,':');
					size = temp2Ptr - crtPtr;
					strncpy(schema[noOfFields].fieldName,crtPtr,size);
					schema[noOfFields].fieldName[size] = 0;
					crtPtr = temp2Ptr+1;

					if ((temp2Ptr = strchr(crtPtr,','))==NULL)
						temp2Ptr = tempPtr;
					else	// a coma found we have to check that this coma is not a part of a type definition like image(0,..)
					{
						if (strchr(crtPtr,'(')!= NULL && strchr(crtPtr,'(') < temp2Ptr)	
							// look for the first comma after the closing ) of that datatype
							temp2Ptr = (strchr(crtPtr,')'))+1;
					}
					size = temp2Ptr - crtPtr;
					strncpy(fieldType,crtPtr,size);
					fieldType[size] = 0;
					crtPtr = temp2Ptr + 2;
					if (*(temp2Ptr+1) == '>')	// this is to avoid continuing search for commas if the data has commas and stop after ">"
						temp2Ptr = tempPtr;

					if (!strncmp("int",fieldType,3))
						schema[noOfFields].type = INT;
					else if (!strncmp("string",fieldType,6))
						schema[noOfFields].type = STRING;
					else if (!strncmp("double",fieldType,6))
						schema[noOfFields].type = DOUBLE;
					else if (!strncmp("image(0, 0, 0)",fieldType,14))
						schema[noOfFields].type = IMAGE;
					else
					{
						delete (record);
						while(!requestTerminated(buf,bytesRead))
							bytesRead = ::recv(socketDesc, buf, RESULT_BUFFER_MAX, 0);
						return ERRINVALIDTYPE;
					}
					noOfFields++;
				}
			}
			schemaRead = 1;
		}

		// the buf is pointing to the begining of the data
		while (1)	// loop on the buffer contents
		{
			int bytesRemaining = &buf[bytesRead] - crtPtr;	// number of characters remaining
			if (bytesRemaining > 1)	// there is still characters in the buffer
			{
				if (!incompleteField && *crtPtr=='\n')	// the start of the data is new line so there is no data
					break;

				if (schema[crtField].type == IMAGE)
				{
					if(!incompleteField) {	// there is NO field that part of it has been read but not all of it
						size = getSize(crtPtr);// this changes the position of the crtPtr
						currentSize=0;	// the size previouslu read from the incomplete field
						bytesRemaining = &buf[bytesRead] - crtPtr; // bytes remaining in the buffer after getting the size
					}
					if (bytesRemaining <= size-currentSize+1)	// the whole image is not there 
					{
						if (incompleteField)	// this image started in a previous read and did not finish in this read
						{	// a buffer already allocated
							////memcpy((void*)((char*)(record->fields[crtField].content)+currentSize),crtPtr,bytesRemaining); // error if crtPtr has \0 character
							// write to the file. The offset and size are already in the record set
							fwrite(crtPtr,sizeof(BYTE),bytesRemaining,g_pTempImageFile);
							currentSize+=bytesRemaining;
						}
						else	// there is no incomplete image and the size is here but this image will not end in this buffer
						{
							record->fields[crtField].size = size;
							////record->fields[crtField].content = malloc (size);
							// the content will be the offset of the image in the file
							record->fields[crtField].content = malloc(sizeof(long));
							long x = ftell(g_pTempImageFile);
							*((long *)record->fields[crtField].content) = x;
							fwrite(crtPtr,sizeof(BYTE),bytesRemaining,g_pTempImageFile); // error if crtPtr has \0 character
							////memcpy(record->fields[crtField].content,(void *)crtPtr,bytesRemaining); // error if crtPtr has \0 character
							record->fields[crtField].type = schema[crtField].type;
							strcpy(record->fields[crtField].fieldName, schema[crtField].fieldName);

							currentSize=bytesRemaining;
							incompleteField = 1;
						}
						crtPtr = &buf[bytesRead];
					}
					else	// the image end is here
					{
						if (incompleteField)
						{	
							////memcpy((void*) ((char*) (record->fields[crtField].content) + currentSize ),
							////		crtPtr,
							////		record->fields[crtField].size - currentSize); 
							// write the remaining of the image in the file
							fwrite(crtPtr,sizeof(BYTE),record->fields[crtField].size - currentSize,g_pTempImageFile);
							crtPtr += (record->fields[crtField].size - currentSize);
							currentSize=0;
							incompleteField = 0;	// the image has been completed
						}
						else	// the whole image is here
						{
							record->fields[crtField].size = size;
							////record->fields[crtField].content = malloc (size);
							record->fields[crtField].content = malloc (sizeof(long));
							////memcpy(record->fields[crtField].content,(void *)crtPtr,size); 
							long x ;
							x = ftell(g_pTempImageFile);
							*((long *)record->fields[crtField].content) = x;
							fwrite(crtPtr,sizeof(BYTE),size,g_pTempImageFile);
							record->fields[crtField].type = schema[crtField].type;
							strcpy(record->fields[crtField].fieldName, schema[crtField].fieldName);
				
							crtPtr += size;
						}

						crtPtr++;	// skip the tab
						crtField++;
						if (crtField == noOfFields)
						{
							//add new record to the array of records
							record->fields[crtField].size = NULLSIZE;	// indicate end of data
							int done =0;
							for (int i=0; i<noOfFields; i++)
								if (record->fields[i].type == STRING && !strncmp("\"@MP",(char *)record->fields[i].content,4))
								{
									record->fields[i].type = STRINGURL;
									done = 1;
								}
							g_cursor.Add(record);
							crtField = 0;
							if (done ) return IGNORERESULT;
							record = new CursorRecord; 
						}

						// to handle the case of new line after the last field in the record or the data
						while (crtPtr == (strchr(crtPtr,'\n')))
							crtPtr++;
					}
				}
				else	// normal type should find the first \t to specify the field width
				{
					if ((tempPtr = strchr(crtPtr,'\t'))!=NULL)
					{
						if (incompleteField)
						{
							size = tempPtr - crtPtr + tempField.size;
							record->fields[crtField].size = size;
							record->fields[crtField].content = malloc (size+1);
							strncpy((char*)record->fields[crtField].content,(char*)tempField.size,tempField.size);
							((char*)record->fields[crtField].content)[tempField.size]=0;
							strncat((char*)record->fields[crtField].content,crtPtr,tempPtr - crtPtr);
							record->fields[crtField].type = schema[crtField].type;
							strcpy(record->fields[crtField].fieldName, schema[crtField].fieldName);

							incompleteField = 0;
							free (tempField.content);
							tempField.size = 0;
						}
						else	// normal case 
						{
							size = tempPtr - crtPtr;
							record->fields[crtField].size = size;
							record->fields[crtField].content = malloc (size+1);
							strncpy((char*)record->fields[crtField].content,crtPtr,size);
							((char*)record->fields[crtField].content)[size]=0;
							record->fields[crtField].type = schema[crtField].type;
							strcpy(record->fields[crtField].fieldName, schema[crtField].fieldName);
						}
						crtPtr = tempPtr + 1;
						crtField++;
						if (crtField == noOfFields)
						{
							//crtRow++;
							record->fields[crtField].size = NULLSIZE;
							int done = 0;
							// check if we should stop here if a returned value is a URL
							for (int i=0; i<noOfFields; i++)
								if (record->fields[i].type == STRING && !strncmp("\"@MP",(char *)record->fields[i].content,4))
								{
									record->fields[i].type = STRINGURL;
									done = 1;
								}
							g_cursor.Add(record);
							crtField = 0;
							
							if (done) return IGNORERESULT;

							record = new CursorRecord; 
						}

						// to handle the case of new line after the last field in the record or the data
						while (crtPtr == (strchr(crtPtr,'\n')))
							crtPtr++;
					}
					else	// there is no tab so the field is in not complete in this buffer
					{
						tempField.size = bytesRemaining;
						tempField.content = malloc(bytesRemaining+1);
						strncpy((char*)tempField.content,crtPtr,bytesRemaining);
						((char*)tempField.content)[bytesRemaining]=0;

						incompleteField =1;
					}
				}// normal field
			}
			else	// byte remaining < 1
				break;
		}	// end current buffer processing 
	
		// check if this is the last buffer in the result only if the previous results are complete
		if (!incompleteField)
			if (requestTerminated(buf, bytesRead))
				break;	
	}
	delete (record);
	return RESULTOK;
}
//------------------------------------------------------------
int PredConnection::getSize(char *&crtPtr)
{
	int recSize;
	char *sizePtr, sizeStr[100], tmpSizeStr[100]; 
	int cnt, tmpCnt;

	cnt = tmpCnt = 0;
	if ((sizePtr = strchr(crtPtr,'@'))!=NULL)
	{
		sizePtr++;	
		while (*sizePtr!='@'){		
			sizeStr[cnt++] = *sizePtr;
			sizePtr++;
		}
		crtPtr = sizePtr +1;	// point to the start of the actual data
		/*
		//Mostafa:Since server is behind UNIX Arch	thn has to switch work
		while(tmpCnt<cnt){			
			tmpSizeStr[0+tmpCnt]=sizeStr[3+tmpCnt];
			tmpSizeStr[1+tmpCnt]=sizeStr[2+tmpCnt];
			tmpSizeStr[2+tmpCnt]=sizeStr[1+tmpCnt];
			tmpSizeStr[3+tmpCnt]=sizeStr[0+tmpCnt];
			tmpCnt = tmpCnt + 4;
		}
		recSize = (int *)tmpSizeStr;	
		return (recSize);*/

        recSize = atoi(sizeStr);
		return (recSize);
	}
	else
		return (0);	// error in the format @ is not found
}
//----------------------------------------------------------------------
int PredConnection::ignoreReply()
{
	if (!valid) 
		return ERRINVALIDCON;

	int socketDesc = socket->socketDesc;
	char buf[RESULT_BUFFER_MAX+1];
	int bytesRead;

	while (1) 
	{
		bytesRead = ::recv(socketDesc, buf, RESULT_BUFFER_MAX, 0);
		if (bytesRead <= 0) 
		{
			perror("Server error:");
			valid = 0;
			return ERR0BYTE;
		}
		buf[bytesRead] = 0;
		if (requestTerminated(buf, bytesRead))
			break;	
	}
	return RESULTOK;
}
