#include "stdafx.h"
#include "txtclient.h"

#ifdef XXX_WIN32
#define strcasecmp(X, Y) _stricmp(X, Y)
#endif

const char* const XxxTxtClientEnv::DefaultPrompt = "Q> ";
const int XxxTxtClientEnv::DefaultPort = 6005;
const int XxxTxtClientEnv::DefaultTiming = 1;
const int XxxTxtClientEnv::DefaultVerbose = 1;
const bool XxxTxtClientEnv::DefaultPrintSchemas = true;
const bool XxxTxtClientEnv::DefaultPrintBinary = false;


//SMostafa
// make Env and Connection global variables not local (was declared in main only)
 XxxTxtClientEnv* Env;
 PredConnection* Connection;

 
 void executeBatchCommand(char * Buf);
//EMostafa


// Returns 1 if the string is terminated by
// a semicolon (possibly followed by whitespace).
// Otherwise returns 0.
inline int SemiColonTerminated(const char* Buf)
{
  // if this is a comment line, dont count it as a terminated line
  if (Buf[0] == '#') return 0; 
  if (Buf[0] == '%') return 0; 

  int BufLen = strlen(Buf);
  for (int i = BufLen-1; i >=0; i--) {
    if (Buf[i] == ';') return 1;
    if (!isspace(Buf[i])) return 0;
  }
  return 0;
}

#ifndef XXX_READLINE
char* readline(char *Prompt)
{
 static char Buf[XXX_INPUT_LINEBUFFER_MAX];

 if (Prompt)
   cout << Prompt;

 if (cin.eof()) return NULL;

 cin.getline(Buf,XXX_INPUT_LINEBUFFER_MAX);

 if (cin.bad()) return NULL;

 return Buf;
}
#endif

int IStreamList::GetCommand(char* Buf, int BufLength, int& CommandLength)
{
 while (1) {
   while (Next && !Next->Stream->good()) {
     IStreamList* Tmp = Next->Next;
     Next->Next = NULL;
     delete Next;
     Next = Tmp;
     Count--;
    }
   if (Empty() || !Next) return 0;

   //if (Next->Stream->get(Buf, BufLength, ';') && (Next->Stream->good()) &&
   if (Next->Stream->get(Buf, BufLength, '\n') && (!Next->Stream->bad()) &&
       (CommandLength = Next->Stream->gcount()))
    {
     // return this command
     // get the ; out of the istream
     //Next->Stream->get();
     //Buf[CommandLength++] = ';';
     //Buf[CommandLength] = 0;
     return 1;
    }
   // else try again!!
  }
}


//
// this is supposed to return a List of IStreams that contains all the strings
// in this particular user request
//
IStreamList* XxxTxtClientEnv::GetInput(int &Status)
{
 char *Buf1;
 IStreamList *InputList = new IStreamList();
 while (1) {
   if (!(Buf1 = readline(DisplayPrompt?Prompt:0))) {
     Status = XXX_CL_QUIT;
     delete InputList;
     return NULL;
    }

#ifdef XXX_READLINE
   add_history(Buf1);
#endif

   if (!strncmp(Buf1, XXX_CL_QUITSTR, strlen(XXX_CL_QUITSTR))) {
     Status = XXX_CL_QUIT;
     delete InputList;
     return NULL;
    }


   if (!strncmp(Buf1, XXX_CL_CONSULTSTR, strlen(XXX_CL_CONSULTSTR))) {
     // get rid of trailing semicolon
     if (Buf1[strlen(Buf1)-1] == ';') Buf1[strlen(Buf1)-1] = 0;
     // account for starting white space
     char *FileName = Buf1+strlen(XXX_CL_CONSULTSTR) + 1;
     ifstream* InputFile = new ifstream(FileName);
     if (!InputFile || !InputFile->good()) {
       cout << "txtclient::Bad input file name " << FileName << endl;
       if (InputFile) delete InputFile;
      }
     else {
       InputList->Add(InputFile);
      } 
   }
   else if (!strncmp(Buf1, XXX_CL_SHELLSTR, strlen(XXX_CL_SHELLSTR))) {
     // get rid of trailing semicolon
     if (Buf1[strlen(Buf1)-1] == ';') Buf1[strlen(Buf1)-1] = 0;
     // account for starting white space
     char *SysCommand = Buf1+strlen(XXX_CL_SHELLSTR) + 1;
     system(SysCommand);
    }

   else if (!strncmp(Buf1, XXX_CL_LABELSTR, strlen(XXX_CL_LABELSTR))) {
     // get rid of trailing semicolon
     if (Buf1[strlen(Buf1)-1] == ';') Buf1[strlen(Buf1)-1] = 0;
     // account for starting white space
     char *TLabel = Buf1+strlen(XXX_CL_LABELSTR) + 1;
     strcpy(TimerLabel, TLabel);
    }

   else if (!strncmp(Buf1, XXX_CL_LANGSTR, strlen(XXX_CL_LANGSTR))) {
     // get rid of trailing semicolon
     if (Buf1[strlen(Buf1)-1] == ';') Buf1[strlen(Buf1)-1] = 0;
     else Buf1[strlen(Buf1)] = 0;
     char *NewLang = Buf1+strlen(XXX_CL_LANGSTR) + 1;
     // account for starting white space
     while (*NewLang && isspace(*NewLang)) NewLang++;
     if (*NewLang) {
       strcpy(CurrentLang, NewLang);
       //strcat(CurrentLang, ":");
       cout << "txtclient::Current Language set to:" << CurrentLang << endl;
      }
     else {
       cout << "txtclient::Current Language:" << CurrentLang << endl;
      }
     }

   else if (!strncmp(Buf1, XXX_CL_DEFSTR, strlen(XXX_CL_DEFSTR))) {
     PrintDefaults(cout);
    }

   else if (!strncmp(Buf1, XXX_CL_OUTFSTR, strlen(XXX_CL_OUTFSTR))) {
     cout << "txtclient::Havent implemented o/p redirection yet" << endl;
   }

   else if (!strncmp(Buf1, XXX_CL_TIMERFSTR, strlen(XXX_CL_TIMERFSTR))) {
     // get rid of trailing semicolon
     if (Buf1[strlen(Buf1)-1] == ';') Buf1[strlen(Buf1)-1] = 0;
     // account for starting white space
     char *TimerFileName = Buf1+strlen(XXX_CL_TIMERFSTR) + 1;
     TimerStr = new ofstream(TimerFileName);
    }

   else if (!strncmp(Buf1, XXX_CL_HELPSTR, strlen(XXX_CL_HELPSTR))) {
     PrintCommandsHelp(cout);
   }

   else if (!strncmp(Buf1, XXX_CL_TOGGLESTR, strlen(XXX_CL_TOGGLESTR))) {
     // account for starting white space
     char *SysCommand = Buf1+strlen(XXX_CL_SHELLSTR) + 1;
     while (*SysCommand && isspace(*SysCommand)) SysCommand++;
     if (*SysCommand) {
       if (!strcasecmp(SysCommand, "timing"))
	 TimingOn = !TimingOn;
       else if (!strcasecmp(SysCommand, "schema"))
	 PrintSchemas = !PrintSchemas;
       else if (!strcasecmp(SysCommand, "binary"))
	 PrintBinary = !PrintBinary;
      }
    }
   //SMostafa
   //Add the feature extraction action as _extract (command)
   else if (!strncmp(Buf1, XXX_CL_EXTRACT, strlen(XXX_CL_EXTRACT))) {	   
		// Add the entry to feature extractionn routine here
	    // each time we need to execute SQL just call executeBatchCommand with the SQL
	    //  statmenmt as the parameter
			executeBatchCommand("select v.movie.ClientStore(\"c:\\test.mpeg\") from vtest v where v.id=\"sample1\";");
   }
   //EMostafa
   else {
     // have to reallocate buffer, since gnu readline tends to
     // reuse allocated memory
     // This is probably a memory leak!
     char* NewBuf = new char[strlen(Buf1)+1];
     memcpy(NewBuf, Buf1, strlen(Buf1)+1);
     InputList->Add(new istrstream(NewBuf));
     // new addition
     if (SemiColonTerminated(NewBuf)) {
       // here's the primary return point
       Status = XXX_CL_OK;
       return InputList;
      }
    } // if not a special command keyword
  } // while (1)
}

/****
-h <hostname> : server hostname
-p <prompt>   : client prompt string
-s <portnum>  : server socket port
-u <username> : client's user's name
-r            : schemas printed with tables
-t            : timing on
****/
void XxxTxtClientEnv::PrintFlagsHelp(ostream& OStr) const
{
 OStr << " PREDATOR Textual Client" << endl;
 OStr << "    -h <server host>" << endl;
 OStr << "    -u <user name>" << endl;
 OStr << "    -l <top language>" << endl;
 OStr << "    -p <prompt>" << endl;
 OStr << "    -s <server port>" << endl;
 OStr << "    -t <0/1> timing off/on" << endl;
 OStr << "    -r <0/1> schema printing off/on" << endl;
 OStr << "    -b <0/1> binary printing off/on" << endl;
}

void XxxTxtClientEnv::PrintCommandsHelp(ostream& OStr) const
{
 OStr << " XXX Textual Client Commands" << endl;
 OStr << "    " << XXX_CL_CONSULTSTR << " <filename>" << endl;
 OStr << "    " << XXX_CL_DEFSTR << " : show default settings" << endl;
 OStr << "    " << XXX_CL_HELPSTR << " : list of commands" << endl;
 OStr << "    " << XXX_CL_LANGSTR << " <language name>  : set the top-level language" << endl;
 OStr << "    " << XXX_CL_LABELSTR << " <timer label>  : set the label for timer info" << endl;
 OStr << "    " << XXX_CL_OUTFSTR << " <outfile name>  : set the answer o/p file" << endl;
 OStr << "    " << XXX_CL_QUITSTR << " (or CTRL-D)  : exit system" << endl;
 OStr << "    " << XXX_CL_SHELLSTR << " <shell command>" << endl;
 OStr << "    " << XXX_CL_TIMERFSTR << " <timerfile name>  : set the timer o/p file" << endl;
 OStr << "    " << XXX_CL_TOGGLESTR << " <timing/schema printing>" << endl;
 //SMostafa
 OStr << "    " << XXX_CL_EXTRACT << " : execute feature extraction routine" << endl;
 //EMostafa
}

void XxxTxtClientEnv::PrintDefaults(ostream& OStr) const
{
 OStr << " XXX Textual Client Defaults" << endl;
 OStr << "    Server Host  : " << HostName << endl;
 OStr << "    Server Port  : " << ServerPort << endl;
 OStr << "    User Name    : " << UserName << endl;
 OStr << "    Top Language : " << CurrentLang << endl;
 OStr << "    User Prompt  : " << Prompt << endl;
 OStr << "    Output File  : " << "cout" << endl;
 OStr << "    Timing       : " << (TimingOn?"on":"off") << endl;
 OStr << "    TimerLabel   : " << TimerLabel << endl;
 OStr << "    Schemas are  : " << (PrintSchemas?"printed":"not printed") << endl;
 OStr << "    Printing  : " << (PrintBinary?"binary":"ASCII") << endl;
}

void XxxTxtClientEnv::ReadCommandLine(int argc, char**argv)
{
 for (int i = 1; i < argc; i++){
   char *flag = argv[i];
   if (flag[0] != '-') {
     cout <<  "txtclient::Bad command line flag " << argv[i] << endl;
     continue;
    }
   switch (flag[1]) {
    case 'h' :
     if (i+1 < argc)
       strcpy(HostName, argv[++i]);
     else 
       cout << "txtclient::Bad command line flag " <<  flag << endl;
     break;

    case 'u' :
     if (i+1 < argc)
       strcpy(UserName, argv[++i]);
     else 
       cout << "txtclient::Bad command line flag " <<  flag << endl;
     break;

    case 'l' :
     if (i+1 < argc)
       strcpy(CurrentLang, argv[++i]);
     else 
       cout << "txtclient::Bad command line flag " << flag << endl;
     break;

    case 'p' :
     if (i+1 < argc)
       strcpy(Prompt, argv[++i]);
     else 
       cout << "txtclient::Bad command line flag " <<  flag << endl;
     break;

    case 'd' :
     if (i+1 < argc)
       DisplayPrompt = (atoi(argv[++i])?true:false);
     else 
       cout << "txtclient::Bad command line flag " << flag << endl;
     break;

    case 's' :
     if (i+1 < argc)
       ServerPort = atoi(argv[++i]);
     else 
       cout << "txtclient::Bad command line flag " << flag << endl;
     break;

    case 't' :
     if (i+1 < argc)
       TimingOn = atoi(argv[++i]);
     else 
       cout << "txtclient::Bad command line flag " << flag << endl;
     break;

    case 'r' :
     if (i+1 < argc)
       PrintSchemas = (atoi(argv[++i])?true:false);
     else 
       cout << "txtclient::Bad command line flag " << flag << endl;
     break;

    case 'b' :
     if (i+1 < argc)
       PrintBinary = (atoi(argv[++i]) ? true : false);
     else 
       cout << "txtclient::Bad command line flag " << flag << endl;
     break;

    case 'e' :
     if (i+1 < argc)
       EchoInput = (atoi(argv[++i])?true:false);
     else 
       cout << "txtclient::Bad command line flag " << flag << endl;
     break;

     default :
     PrintFlagsHelp(cout);
     exit(EXIT_FAILURE);
    }
  }

}

void XxxTxtClientEnv::TimerStart()
{
#ifdef XXX_WIN32
  // Time = CTime::GetCurrentTime();
  Time = clock();
#else
 struct timezone Temp;
 gettimeofday(&Time, &Temp);
#endif
}

void XxxTxtClientEnv::TimerDisplay(ostream& OStr)
{
 OStr << TimerLabel << " ";
#ifdef XXX_WIN32
 /***
 CTime NewTime = CTime::GetCurrentTime();

 CTimeSpan TSpan = NewTime - Time;
 OStr << TSpan.GetTotalSeconds();
 ****/
 clock_t NewTime = clock();
 OStr << (double)(NewTime - Time) / CLOCKS_PER_SEC;
#else
 struct timeval NewTime;
 struct timezone Temp;
 gettimeofday(&NewTime, &Temp);

 OStr << (NewTime.tv_sec-Time.tv_sec)+(NewTime.tv_usec-Time.tv_usec)/1000000.0;
#endif
 OStr << " secs" << endl;
}


main(int argc, char**argv)
{
 XxxSocketStarter DummyStarter;
 Env = new XxxTxtClientEnv(argc, argv);
 // cout << "providing : binary " << (int)Env->PrintBinary ;
 // cout << ", schemas " << (int)Env->PrintSchemas << endl;
 Connection = 
   new PredConnection(Env->HostName, Env->ServerPort,
		      Env->UserName, "password",
		      Env->PrintBinary, Env->PrintSchemas);

 if (!Connection->IsValid()) {
   cout << "txtclient::Did not establish connection to server" << endl;
   delete Connection;
   exit(EXIT_FAILURE);
  }

 char Buf[XXX_INPUT_BUFFER_MAX];
 IStreamList* InputList;

 while (1) {
   int Status;
   int LangNameOffset = strlen(Env->CurrentLang);
   InputList = Env->GetInput(Status);
   if (Status == XXX_CL_OK) {
	 int BytesToWrite;
     char Buf1[XXX_INPUT_BUFFER_MAX];
     strcpy(Buf1, Env->CurrentLang);
     strcat(Buf1, ":");

     while (InputList->GetCommand(Buf, XXX_INPUT_BUFFER_MAX, BytesToWrite)) {
       // check that there is no overflow
       if (strlen(Buf1) + strlen(Buf) + 2 >= XXX_INPUT_BUFFER_MAX) {
			cout << "txtclient::Overflowing txtclient input buffer!" << endl;
			exit(EXIT_FAILURE);
		}
	    strcat(Buf1, Buf);
		strcat(Buf1, "\n");  // tack on a newline
     }
     if (Env->EchoInput)
       *(Env->OutStr) << Env->Prompt << Buf1+LangNameOffset+1;
     if (!Connection->SendRequest(Buf1)) {
       cout << "txtclient::Error sending request to server" << endl;
       delete Connection;
       exit(EXIT_FAILURE);
      }
     delete InputList;
    }
   else { // XXX_CL_QUIT
     if (InputList) delete InputList;
     break;
    }

   if (Env->TimingOn) Env->TimerStart();

   if (!Connection->PrintReply(*(Env->OutStr))) {
     cout << "txtclient::Error getting reply from server" << endl;
     delete Connection;
     exit(EXIT_FAILURE);
    }

   if (Env->TimingOn)
     Env->TimerDisplay(*(Env->TimerStr));

  } // while (1)

 if (Env->DisplayPrompt) 
   cout << "Shutting down connection ... " ;
 delete Connection;
 if (Env->DisplayPrompt) 
   cout <<  "goodbye" << endl;
 delete Env;

 return 0;
}



void executeBatchCommand(char * Buf){
	
	char Buf1[XXX_INPUT_BUFFER_MAX];		

	strcpy(Buf1, Env->CurrentLang);
	strcat(Buf1, ":");     	

	if (strlen(Buf1) + strlen(Buf) + 2 >= XXX_INPUT_BUFFER_MAX) {
		cout << "txtclient::Overflowing txtclient input buffer!" << endl;
		exit(EXIT_FAILURE);
	}
	strcat(Buf1, Buf);
	strcat(Buf1, "\n");  // tack on a newline
	
	if (Env->EchoInput)
		*(Env->OutStr) << Env->Prompt << Buf1+ strlen(Env->CurrentLang)+1;
	if (!Connection->SendRequest(Buf1)) {
		cout << "txtclient::Error sending request to server" << endl;
		delete Connection;
		exit(EXIT_FAILURE);
	}
	if (Env->TimingOn) Env->TimerStart();

	if (!Connection->PrintReply(*(Env->OutStr))) {
		cout << "txtclient::Error getting reply from server" << endl;
		delete Connection;
		exit(EXIT_FAILURE);
	}

	if (Env->TimingOn)
		Env->TimerDisplay(*(Env->TimerStr));
}
